﻿Imports System.IO
Imports Strings = Microsoft.VisualBasic ' so can use things like left( and right( for strings
Public Class frmMain
    'http://dimac.net/default3.asp?M=FreeDownloads/Menu.asp&P=FreeDownloads/FreeDownloadsstart.asp
    ' Get the free download called w3sockets half way down the page
    ' put the sockets.dll file in c:\windows\system32
    ' run the SocketReg program
    'Your application needs to be aware of the socket.dll file, I accomplished this as follows:
    '1. Click on the 'Project' menu and select 'Add reference...'
    '2. Click on the 'Browse' tab
    '3. Navigate to where you have socket.dll installed on the HD
    '4. Select this file and click 'OK'
    Private WithEvents w3sock As Socket.TCP ' needs 
    Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Integer) ' for sleep statements
    Public Declare Auto Function SendMessage Lib "user32.dll" (ByVal hWnd As IntPtr, ByVal wMsg As Int32, ByVal wParam As IntPtr, ByVal lParam As IntPtr) As IntPtr ' disable redrawing of richtextbox etc
    Public Const WM_SETREDRAW As Int32 = &HB ' for above sendmessage
    Dim WithEvents SerialPort As New IO.Ports.SerialPort ' serial port declare
    Dim InPacket(0 To 2000) As Byte ' Major bug with serial.write strings like chr(255) won't go out
    Dim OutPacket(0 To 2000) As Byte
    Dim XOut(0 To 133) As Byte ' xmodem output packet
    Public CursX As Integer
    Public CursY As Integer
    Public Display(81, 41) As String
    Public Redrawing As Boolean ' flag to disable textboxchanged
    Public OldCursorPos As Integer
    Public CaptureFlag As Boolean
    Public TypematicSlow As Boolean
    Public KeyCounter As Integer
    Public SbasicFile As String
    Public BDSCfile As String
    Public BDSCchanged As Boolean
    Public SbasicRedraw As Integer
    Public ComboBoxEnable As Boolean = False
    Public SbasicChanged As Boolean = False
    Public ColorOn As Boolean = True
    Public Richtext3Updated As Boolean = False
    Public Startup As Boolean = True
    Public SerialPortFound As Boolean = True
    Public EchoOn As Boolean = True
    Public RadioAsciiCharacters As Boolean = False
    Public AssemblyFile As String
    Sub SaveTextFileExample() ' not used at present, just to remind me how it is done
        FileOpen(1, "test.txt", OpenMode.Output) ' open a file
        PrintLine(1, "line1")
        FileClose(1)
    End Sub
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' startup
        SerialPort.ReadTimeout = 100
        w3sock = New Socket.TCP
        Timer1.Interval = 150 ' check for new characters every 150ms
        'TextBox3.ForeColor = Color.LawnGreen
        'TextBox3.BackColor = Color.Black
        CaptureFlag = False
        TypematicSlow = False
        Call StartScreen()
        Call LoadINI()
        Try
            ' set the portname and baudrate in the loadini subroutine
            'SerialPort.PortName = "COM1"
            'SerialPort.BaudRate = "38400" ' 38400
            SerialPort.Parity = IO.Ports.Parity.None ' no parity
            SerialPort.DataBits = 8 ' 8 bits
            SerialPort.StopBits = IO.Ports.StopBits.One ' one stop bit
            'SerialPort.ReadTimeout = 1000 ' milliseconds so times out in 1 second if no response
            SerialPort.Open() ' open the port
            SerialPort.DiscardInBuffer() ' clear the input buffer
        Catch ex As Exception
            MsgBox("Error opening serial port - is another program using the selected COM port? This program will continue running but with no serial port comms. Also another possible error is the w3sockets.dll is not installed (needed to talk to the altair). Get the w3sockets.zip from the Mini N8vem Files folder on the wiki, then unzip and put the sockets.dll in c:\windows\system32. Then run the registration program")
            SerialPortFound = False
        End Try
        RichTextBox2.Visible = False
        Call LoadSbasicLibrary()
        RichTextBox1.AcceptsTab = True ' so tab stays in the rich text box
        RichTextBox4.AcceptsTab = True
        Timer1.Enabled = True   ' turn on the timer
        Call LoadRomSettings()
        Me.WindowState = FormWindowState.Maximized
    End Sub
    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        If SerialPortFound = True Then
            SerialPort.Close()
        End If
        If SbasicFile <> "" And SbasicChanged = True Then
            Call SaveSbasicFile()
        End If
        End
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        ' collect bytes from the serial port
        Timer1.Enabled = False
        Static TimerCounter As Integer
        Dim LineOfText As String
        If SerialPortFound = True Then
            Call ReadSerialPort()
            If SbasicRedraw >= 0 Then
                SbasicRedraw = SbasicRedraw + 1 ' if no keypress for 5 secs then redraw
            End If
            If SbasicRedraw > 40 Then
                Call ColorSbasic()
                SbasicRedraw = -1 ' disable counter till at least one keypress
            End If
            TimerCounter = TimerCounter + 1
            If TimerCounter > 12 And Richtext3Updated = False Then
                TimerCounter = 0
                RichTextBox3.SelectionStart = RichTextBox3.TextLength
                RichTextBox3.ScrollToCaret()
                Richtext3Updated = True
                If SerialPortFound = True Then
                    LineOfText = Str(SerialPort.BaudRate)
                End If
                Label7.Text = "Baud rate: " + LineOfText
            End If
            If Startup = True And TimerCounter > 2 Then
                TabControl1.SelectedIndex = 0
                TextBox3.Focus()
                Call StringToPacket(vbCrLf) ' send a carriage return to get the A> prompt
                Startup = False
            End If
        End If
        Timer1.Enabled = True
    End Sub
    Sub ReadSerialPort()
        Dim BytesToRead As Integer '  may as well get in batches
        Dim i As Integer
        Dim j As Integer
        Dim Character As String
        Dim LineOfText As String
        Static ControlA As Boolean
        Static CaptureXmodem As String
        Dim XmodemBytes As Long
        If SerialPortFound = True Then
            Do
                'Try
                If SerialPort.BytesToRead = 0 Then Exit Do ' no more bytes
                BytesToRead = SerialPort.BytesToRead
                If BytesToRead > 2000 Then BytesToRead = 2000
                SerialPort.Read(InPacket, 0, BytesToRead) ' read in a packet
                For i = 1 To BytesToRead
                    Character = Strings.Chr(InPacket(i - 1))
                    Timer1.Enabled = False ' displaycharacter can take a while, more than one tick
                    If Character = Strings.Chr(1) Then
                        ControlA = True
                    Else
                        ControlA = False
                    End If
                    If ControlA = True Or Strings.Len(CaptureXmodem) <> 0 Then
                        CaptureXmodem = CaptureXmodem + Character
                    End If
                    If Strings.Len(CaptureXmodem) = 3 Then
                        If Asc(Strings.Mid(CaptureXmodem, 2, 1)) = 255 - Asc(Strings.Mid(CaptureXmodem, 3, 1)) Then
                            XmodemBytes = Asc(Mid(CaptureXmodem, 2, 1)) * 128
                            LineOfText = vbCrLf + "[ Packet number:" + Str(Asc(Mid(CaptureXmodem, 2, 1))) + " =" + Str(XmodemBytes) + " Bytes ]" + vbCrLf
                            For j = 1 To Len(LineOfText)
                                Call DisplayCharacter(Mid(LineOfText, j, 1))
                            Next
                        End If
                    End If
                    If Strings.Len(CaptureXmodem) > 4 Then CaptureXmodem = ""
                    Call DisplayCharacter(Character) ' display the character
                    If RadioAsciiCharacters = True Then
                        LineOfText = Trim(Str(Asc(Character)))
                        Call DisplayCharacter("[")
                        For j = 1 To Len(LineOfText)
                            Call DisplayCharacter(Mid(LineOfText, j, 1))
                        Next
                        Call DisplayCharacter("]")
                        Call DisplayCharacter(Chr(13))
                        Call DisplayCharacter(Chr(10))
                    End If
                    Call ScrollWindow(Character) ' altair simh window
                    Timer1.Enabled = True
                    If CaptureFlag = True Then
                        Call CaptureText(Character)
                    End If
                Next
                Call RedrawDisplay()
                'Catch ex As Exception
                'MsgBox("Serial port error in ReadSerialPort - this program requires a serial connection to run and will now shut down.")
                ' unfortunately it is not possible to have a message explaining the error for clicking ok takes >150ms by which time it has run again, and it won't disable the timer, all most odd.
                ' but this should never run because it should have been flagged on startup
                'End Try
            Loop
        End If
    End Sub
    Sub ScrollWindow(ByVal Character As String)
        If Asc(Character) <> 10 Then ' altair simh window
            RichTextBox3.AppendText(Character)
            Richtext3Updated = False
        End If
    End Sub
    Sub StringToPacket(ByVal lineoftext As String)
        ' send a string out, but don't use for data as numbers like 255 don't work
        ' also don't go over 30 (CPM commands never would be)
        Dim i As Byte
        Dim PacketLength As Byte
        Dim TypematicDelay As Integer
        Dim Character As String
        PacketLength = Strings.Len(lineoftext)
        TypematicDelay = 50
        ' 120 for 4800 baud don't go too short otherwise errors, errors at 60 for instance at 4800
        ' errors below 10 at 38400 baud
        ' needs 60 to send and 60 to get character back, so slow but it works
        ' comment - for some reason at wired 38400 we need the slow speed yet can send out as a whole string for radio at 1200?
        If TypematicSlow = False Then
            Sleep(TypematicDelay) ' typematic delay - depends on clock as much as baud rate
            For i = 1 To PacketLength
                OutPacket(0) = Strings.Asc(Strings.Mid(lineoftext, i, 1))
                If SerialPortFound = True Then
                    SerialPort.Write(OutPacket, 0, 1)
                End If
                Sleep(TypematicDelay)
                System.Windows.Forms.Application.DoEvents() ' update the display
            Next
        Else
            ' Yishi radio links
            ' need quite high delays (500) if echo is on as waiting for bytes back too
            ' 100 works 21st Feb 2009
            ' new experiments March 2009 with short delays which works well because rf modules send as packets anyway
            TypematicDelay = 300 'does work at 50 but set to 300 to be sure
            ' working at 50 but see if can go faster with custom inkey code on the board
            ' if echo is on the remote board then needs 300. If echo is off then can go to 50
            ' but how do you send the word echooff if it happens to be on
            ' unless just accept slow pc to board commands
            ' board to board commands can be faster because all boards boot up with echooff
            Sleep(TypematicDelay) ' typematic delay - depends on clock as much as baud rate
            For i = 1 To PacketLength
                OutPacket(0) = Strings.Asc(Strings.Mid(lineoftext, i, 1))
                If SerialPortFound = True Then
                    SerialPort.Write(OutPacket, 0, 1)
                End If
                Sleep(TypematicDelay)
                Character = Strings.Mid(lineoftext, i, 1)
                If EchoOn = False Then
                    Call DisplayCharacter(Character)
                    Call RedrawDisplay()
                    System.Windows.Forms.Application.DoEvents()
                End If
            Next
            ' send as string but seems to fail with the yishi boards
            'For i = 1 To PacketLength
            ' OutPacket(i - 1) = Strings.Asc(Strings.Mid(lineoftext, i, 1))
            'Next
            'SerialPort.Write(OutPacket, 0, PacketLength)
        End If
        System.Windows.Forms.Application.DoEvents() ' update the display
    End Sub
    Private Sub ComPortToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComPortToolStripMenuItem.Click
        Dim Filenamepath As String
        Dim Filepath As String
        Dim Result
        Filepath = "c:\N8VEM"
        OpenFileDialog1.Multiselect = True
        OpenFileDialog1.InitialDirectory = Filepath
        OpenFileDialog1.FileName = "*.*" ' ? put CPM files somewhere safe
        Result = OpenFileDialog1.ShowDialog()
        If Result = 1 Then ' clicked ok 
            For Each Filenamepath In OpenFileDialog1.FileNames
                Call XModemFSend(Filenamepath, True)
            Next Filenamepath
        End If
    End Sub
    Sub XModemSend(ByRef FName As String, ByVal TimerRestart As Boolean)
        Dim Filenamepath As String
        Dim j As Integer
        Dim k As Integer
        Dim LineOfText As String
        Dim SerialString As String
        Dim Counter As Integer
        Dim ErrorString As String
        Dim Packetnumber As Integer
        Dim Checksum As Long
        Dim OnesComplement As Byte
        Dim ByteRead As Byte
        Dim BinaryFileLength As Long
        Dim BinaryFileCounter As Long
        Dim Percent As Single
        Dim ErrorCounter As Byte ' 0 to 10
        Dim CPMFilename As String
        ProgressBar1.Maximum = 100
        ProgressBar1.Minimum = 0
        ' timer restart =true for sending via menu. False for auto send
        Filenamepath = FName
        Packetnumber = 1 ' 1 for the first packet (not zero)
        Try
            Dim Input As New FileStream(Filenamepath, FileMode.Open, FileAccess.Read)
            Dim br As New BinaryReader(Input)
            Label3.Text = "Error Count"
            Label2.Text = "0%"
            BinaryFileLength = br.BaseStream.Length() - 1
            'i = Len(Filepath) + 1 + 1  ' eg c:\n8vem and a \ = 9 and 1 more for start of name only
            Call Get_CPM_Filename(Filenamepath, CPMFilename)
            CPMFilename = Strings.UCase(CPMFilename)
            ' send a <CR>  (in case some rubbish characters on the screen)
            ' LineOfText = Strings.Chr(13)
            ' Call StringToPacket(LineOfText)
            ' Sleep(300) ' 300 for 4800 to process the return
            ' erase the file in case it exists
            ' Call StringToPacket(vbCrLf) ' in case need to kick start it even more
            ' Sleep(300)
            LineOfText = "ERA " + CPMFilename + vbCr
            Call StringToPacket(LineOfText)
            'LineOfText = vbCrLf
            'Call StringToPacket(LineOfText)
            Sleep(300) ' 1000 for 4800 ' 300
            ' run xmodem on the board
            LineOfText = "XMODEM R " + CPMFilename + vbCr
            Call StringToPacket(LineOfText) ' 
            'LineOfText = vbCrLf
            'Call StringToPacket(LineOfText) ' send a return/LF
            Sleep(500) ' wait for text to come back before disabling timer
            ' 100 is a bit short, 300 works, 200 seems a bit better 
            ' xmodem is taking 2 seconds to acknowledge so have at least this much time
            ' to get the text back
            If TimerRestart = False Then
                Call ClearInputBuffer()  ' clear the buffer into the PC
            End If
            If TimerRestart = True Then Timer1.Enabled = False 'disable echo and all reads so can control them below
            ' if timerrestart=false then called from a program where it is already disabled
            ' now wait for the N8VEM to send a chr(21) - will still be echoing back the text for a bit
            Do
                SerialString = ""
                If SerialPortFound = True Then
                    If SerialPort.BytesToRead > 0 Then
                        SerialPort.Read(InPacket, 0, 1) ' get one byte
                        SerialString = Chr(InPacket(0)) ' get a single character/string/byte
                    End If
                End If
                If InPacket(0) = 21 Then
                    ErrorString = "NAK"
                    Exit Do ' got a ^U
                End If
                If SerialString <> "" Then
                    'LineOfText = SerialString
                    'Call TextLines(LineOfText) ' print it out unless it is a chr21
                End If
                Counter = Counter + 1
                Sleep(10) ' don't change this one - this is waiting for NAK
                Label1.Text = "Waiting for NAK to start" + Strings.Str(Counter * 10) + "ms" ' display in milliseconds
                System.Windows.Forms.Application.DoEvents() ' update the label1 message
                ' add a counter and timeout if nothing
                If Counter > 800 Then ' 800
                    ErrorString = "Timeout"
                    Exit Do
                End If
                If ErrorString <> "" Then Exit Do
            Loop
            Label1.Text = ErrorString
            ' bug with vb.net - strings don't go to 255 so have to send data as bytes
            Do
                ' act on each byte in the buffer array here
                Sleep(1) ' 60 for 4800 but 1 working for 38400
                'If Radio1200 = True Then Sleep(250)
                XOut(0) = 1 'SOH ^A
                XOut(1) = Packetnumber
                OnesComplement = 255 - Packetnumber
                XOut(2) = OnesComplement
                Packetnumber = Packetnumber + 1
                If Packetnumber > 255 Then Packetnumber = Packetnumber - 256
                Checksum = 0
                For i = 0 To 127 ' get 128 bytes from file
                    If BinaryFileCounter <= BinaryFileLength Then
                        ByteRead = br.ReadByte ' get a byte
                    Else
                        ByteRead = 26 ' pad with char 26 = hex 1A because hyperterm does this ? why but it works
                    End If
                    XOut(i + 3) = ByteRead
                    Checksum = Checksum + ByteRead
                    BinaryFileCounter = BinaryFileCounter + 1
                Next
                ' create checksum
                Do
                    If Checksum < 256 Then Exit Do ' work out checksum
                    Checksum = Checksum - 256
                Loop
                XOut(131) = Checksum
                Call OutputXout()
                System.Windows.Forms.Application.DoEvents() ' update the label
                Do
                    k = 0
                    Do
                        Sleep(10) '80 for 4800  wait for the acknowledge which is a character 6 delay of 80 only occasionally loops so k>0
                        If SerialPortFound = True Then
                            j = SerialPort.BytesToRead
                        End If
                        If j >= 1 Then
                            If SerialPortFound = True Then
                                SerialPort.Read(InPacket, 0, 1) ' get one byte
                            End If
                            Exit Do
                        End If
                        k = k + 1
                        If k > 70 Then
                            InPacket(0) = 0 ' for below error testing
                            Exit Do
                        End If
                    Loop
                    If InPacket(0) = 6 Then Exit Do ' board got the packet
                    If InPacket(0) = 21 Or InPacket(0) = 0 Then
                        ' didn't get it so try sending again
                        ErrorCounter = ErrorCounter + 1
                        Call OutputXout()
                        Label3.Text = "Error: " + Strings.Str(ErrorCounter)
                        System.Windows.Forms.Application.DoEvents() ' update the label
                    End If
                    Label3.Text = "Error: " + Strings.Str(ErrorCounter)
                    System.Windows.Forms.Application.DoEvents() ' update the label
                    If ErrorCounter >= 10 Then Exit Do
                Loop
                If ErrorCounter >= 10 Then
                    Label1.Text = "10 errors - aborting"
                    Label2.Text = "0%"
                    OutPacket(0) = 24 ' send a ^X cancel
                    If SerialPortFound = True Then
                        SerialPort.Write(OutPacket, 0, 1) ' send 1 byte
                        OutPacket(0) = 3 ' send a ^C
                        SerialPort.Write(OutPacket, 0, 1) ' send 1 byte
                    End If
                    Exit Do
                End If
                If BinaryFileCounter > BinaryFileLength Then Exit Do ' finish up
                Label1.Text = "Sent packet: " + Strings.Str(Packetnumber) + " = OK"
                Percent = BinaryFileCounter / BinaryFileLength
                Percent = Percent * 100
                Percent = Int(Percent)
                Label2.Text = Strings.Str(Percent) + "%"
                ProgressBar1.Value = Percent
            Loop
            If ErrorCounter < 10 Then
                Sleep(100)
                OutPacket(0) = 4
                If SerialPortFound = True Then
                    SerialPort.Write(OutPacket, 0, 1) ' send 1 byte
                End If
                Label2.Text = "100%"
                Label1.Text = "Finished all OK"
                ProgressBar1.Value = 0 'done
            End If
            Input.Close()
            Sleep(200) ' wait for next file
            If TimerRestart = True Then Timer1.Enabled = True ' update the text - no sleeps after this
            System.Windows.Forms.Application.DoEvents() ' update the labels
        Catch ex As Exception
            Close()
            Label1.Text = Filenamepath + " not found"
            If TimerRestart = TimerRestart = True Then Timer1.Enabled = True ' update the text
            System.Windows.Forms.Application.DoEvents() ' update the labels
            Sleep(1000) ' so time to read message
        End Try
    End Sub
    Sub OutputXout() ' uses xout() array and sends it out in pieces of 30 bytes
        ' in a subroutine so resends are easier - passing subroutine fills up the bytes
        ' 1. an SOH byte                             {1 byte}
        ' 2. the packet number                       {1 byte}
        ' 3:      .the(1) 's complement of the packet number {1 byte}
        ' 4. the packet                            {128 bytes}
        ' 5. the checksum                            {1 byte}

        'The following terms are simply ascii codes:
        'SOH = chr(1)  = CTRL-A =
        'EOT = chr(4)  = CTRL-D = End of Transmission
        'ACK = chr(6)  = CTRL-F = Positive Acknowledgement
        'NAK = chr(21) = CTRL-U = Negative Acknowledgement
        'CAN = Chr(24) = CTRL - X = Cancel
        'The packet number sent is simply the number of the packet.  If the packet
        'number is greater than 255, then subtract 256 repeatly until the number is
        'between 0 and 255.  For example, if you were sending packet 731, then you
        'would send 731 - 256 - 256 = 219.
        'The(1) 's complement of a byte (to make life easy) is simply 255 minus the
        'byte.  For example, if you had to take the 1's complement of 142, the answer
        'would be 255 - 142 = 133.

        'The checksum is the value of all the bytes in the packet added together.  For
        'example, if the first five bytes were 45, 12, 64, 236, 173 and the other 123
        'bytes were zeroes, the checksum would be 45+12+64+236+173+0+0+...+0 = 530.
        'However, to make each block one byte smaller, they repeatly subtract 256
        'from the checksum until it is between 0 and 255.  In this case, the checksum
        'would be 530 - 256 - 256 = 18.
        'The(downloader)

        '1. ensures that the packet number sent matches the actual packet number
        'that it is (If the third block send has a '4' as the second byte,
        'something is wrong --> CANCEL TRANSFER (send CAN byte))
        '2. adds the packet number and the 1's complement of it together to make
        'sure that they add up to 255.  if they don't --> CANCEL TRANSFER
        '3. adds up all the bytes in the packet together --> THE SUM
        '4. compares the last two significant digits of THE SUM with the checksum
        '5. if everything looks ok (sum=checksum), then the downloader appends the
        'bytes in the packet to the file being created (sent).  The down-
        'loader then sends an ACK byte which tells the uploader to send the
        'next block.
        'if the sums do not match then the downloader sends an NAK byte which
        'tells the uploader to send the same block it just sent over again.

        ' send in blocks of 30 bytes to keep the Hope module happy
        ' removed the 30 byte block for the moment, hope modules go via boards not pc to board
        Dim i As Integer
        For i = 0 To 131
            OutPacket(i) = XOut(i)
        Next
        If SerialPortFound = True Then
            SerialPort.Write(OutPacket, 0, 132)
        End If
        ' very slow code to catch bugs etc

        'Dim lineoftext As String
        'For i = 0 To 131
        ' OutPacket(0) = XOut(i)
        ' SerialPort.Write(OutPacket, 0, 1)
        ' lineoftext = Chr(XOut(i)) ' + "  " + Str(XOut(i))
        ' Call DisplayCharacter(lineoftext)
        ' Call RedrawDisplay()
        ' System.Windows.Forms.Application.DoEvents()
        ' Sleep(100)
        ' Next

    End Sub
    Sub CancelXmodem()
        ' sends a series of CAN bytes - ascii 24
        Dim i As Integer
        If SerialPortFound = True Then
            For i = 0 To 10
                OutPacket(0) = 24
                SerialPort.Write(OutPacket, 0, 1) ' send 1 byte
                Sleep(200)
            Next i
        End If
    End Sub
    Private Sub CancelSessionToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CancelSessionToolStripMenuItem.Click
        Call CancelXmodem()
    End Sub

    Private Sub ReceiveFileToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ReceiveFileToolStripMenuItem.Click
        Dim Filenamepath As String
        Dim Filepath As String
        Dim Result
        Filepath = "c:\N8VEM"
        SaveFileDialog1.InitialDirectory = Filepath
        SaveFileDialog1.FileName = "*.*" ' ? put CPM files somewhere safe
        Result = SaveFileDialog1.ShowDialog()
        If Result = 1 Then ' clicked ok 
            Filenamepath = SaveFileDialog1.FileName
            Call XModemReceive(Filenamepath, True)
        End If
    End Sub
    Sub XModemReceive(ByRef Filenamepath As String, ByVal TimerRestart As Boolean)
        ' pass full path eg C:\n8vem\FILE.TXT
        ' true for calls from menu bar, false for calls from pip
        'Dim Filepath As String
        Dim FileName As String
        Dim XModemIn(0 To 131) As Byte
        Dim PacketSave(0 To 127) As Byte
        Dim i As Integer
        Dim LineOfText As String
        Dim Packetnumber As Integer
        Dim OnesComplement As Byte
        Dim BinaryFileLength As Long
        Dim ErrorCounter As Byte ' give up if gets to 10
        Dim Checksum As Long
        Dim ValidPacket As Boolean
        Dim ErrorType As String
        Dim BytesToRead As Integer
        Packetnumber = 1 ' I think it is 1 for the first packet
        Dim Output As New FileStream(Filenamepath, FileMode.Create, FileAccess.Write)
        Dim br As New BinaryWriter(Output)
        BinaryFileLength = br.BaseStream.Length() - 1
        FileName = Strings.Mid(Filenamepath, 10) ' strip off c:\N8VEM\
        FileName = Strings.UCase(FileName) ' upper case
        LineOfText = Strings.Chr(13)
        Call StringToPacket(LineOfText)
        Sleep(300) ' to process the return
        ' run xmodem on the board
        System.Windows.Forms.Application.DoEvents() ' update the label1 message
        LineOfText = "XMODEM S " + FileName
        Call StringToPacket(LineOfText) ' start xmodem
        LineOfText = vbCrLf
        Call StringToPacket(LineOfText) ' send a return/LF
        System.Windows.Forms.Application.DoEvents() ' update the label1 message
        Sleep(3000) ' wait a few seconds for the text to come back 
        System.Windows.Forms.Application.DoEvents() ' update the label1 message
        If TimerRestart = False Then
            Call ClearInputBuffer()  ' clear the buffer into the PC
        End If
        If TimerRestart = True Then Timer1.Enabled = False 'disable echo and all reads so can control them below
        OutPacket(0) = 21 ' send a NAK
        If SerialPortFound = True Then
            SerialPort.Write(OutPacket, 0, 1) ' send it out
        End If
        Sleep(1000) ' wait for xmodem to put the line together
        Packetnumber = 1
        Label2.Text = ""
        Do
            ' get first byte back
            ValidPacket = True ' start with true but errors could make it false
            Try
                If SerialPortFound = True Then
                    SerialPort.Read(InPacket, 0, 1)
                End If
            Catch
                ValidPacket = False
                ErrorCounter = ErrorCounter + 1
                ErrorType = "Serial port timeout"
            End Try
            If InPacket(0) = 4 Then
                Label1.Text = "Finished transfer"
                Label2.Text = "100%"
                Exit Do
            End If
            If InPacket(0) = 1 Then
                ' valid packet so read the rest in
                XModemIn(0) = InPacket(0) ' already got the 1st byte so put it in xmodemin array
                If SerialPortFound = True Then
                    For i = 1 To 131
                        SerialPort.Read(InPacket, 0, 1)
                        'Sleep(3) ' average of 50x4=200ms in a packet 
                        XModemIn(i) = InPacket(0)
                    Next
                End If
                Label1.Text = "Packet " + Strings.Str(Packetnumber) ' display packet
                System.Windows.Forms.Application.DoEvents() ' update the label1 message
            End If
            If XModemIn(0) <> 1 And ValidPacket = True Then ' first number should be a 1
                ValidPacket = False
                ErrorType = "First # not ^A SOH"
                ErrorCounter = ErrorCounter + 1
            End If
            Do
                If Packetnumber < 256 Then Exit Do
                Packetnumber = Packetnumber - 256
            Loop
            OnesComplement = 255 - Packetnumber ' ones complement must match
            If Packetnumber <> XModemIn(1) And ValidPacket = True Then ' packet number should be the next one
                ValidPacket = False
                ErrorType = "Packet number mismatch"
                ErrorCounter = ErrorCounter + 1
            End If
            If XModemIn(2) <> OnesComplement And ValidPacket = True Then
                ValidPacket = False
                ErrorType = "Ones complement not valid"
                ErrorCounter = ErrorCounter + 1
            End If
            Checksum = 0
            For i = 3 To 130
                Checksum = Checksum + XModemIn(i)
            Next
            Do
                If Checksum < 256 Then Exit Do ' work out checksum
                Checksum = Checksum - 256
            Loop
            If Checksum <> XModemIn(131) And ValidPacket = True Then
                ValidPacket = False
                ErrorType = "Checksum invalid"
                ErrorCounter = ErrorCounter + 1
            End If
            If ValidPacket = True Then ' got a good packet
                Sleep(1) ' 50 at 4800 wait a tick then acknowledge that got it
                OutPacket(0) = 6 ' got the packet ^F=ACK
                If SerialPortFound = True Then
                    SerialPort.Write(OutPacket, 0, 1) ' send it out
                End If
                Sleep(50) ' 400 at 4800 wait for next packet to all come through - at least 200ms in pauses, plus the data, 200 does work but make it 400
                For i = 3 To 130
                    PacketSave(i - 3) = XModemIn(i) ' read for save
                Next
                Output.Write(PacketSave, 0, 128) ' save 128 bytes
                Packetnumber = Packetnumber + 1
            Else ' an error
                ' don't add one to packet number
                ' send a NAK
                ' try again
                Sleep(50) ' wait a tick then ask to send again
                OutPacket(0) = 21 ' NAK
                If SerialPortFound = True Then
                    SerialPort.Write(OutPacket, 0, 1) ' send it out
                End If
                Sleep(3000) ' wait for next packet to all come through - at least 200ms in pauses, plus the data, 200 does work but make it 400
            End If
            Label3.Text = "Error: " + Strings.Str(ErrorCounter) + " " + ErrorType
            System.Windows.Forms.Application.DoEvents() ' update the label1 message
            If ErrorCounter >= 10 Then Exit Do
        Loop
        If ErrorCounter < 10 Then
            ' tell board got it all ok
            OutPacket(0) = 21
            If SerialPortFound = True Then
                SerialPort.Write(OutPacket, 0, 1)
            End If
            Sleep(100)
            ' expect back a 4, and then send a 6
            OutPacket(0) = 6
            If SerialPortFound = True Then
                SerialPort.Write(OutPacket, 0, 1)
            End If
        Else
            Label1.Text = "File transfer failed"
            Label2.Text = "0%"
            System.Windows.Forms.Application.DoEvents() ' update the label1 message
            For i = 1 To 10
                OutPacket(0) = 24 ' ^X cancel send 10 times
                If SerialPortFound = True Then
                    SerialPort.Write(OutPacket, 0, 1) ' send it out
                End If
                Sleep(200)
            Next i
            OutPacket(0) = 3 ' ^C
            If SerialPortFound = True Then
                SerialPort.Write(OutPacket, 0, 1) ' send it out
            End If
        End If
        If TimerRestart = True Then Timer1.Enabled = True 'turn the timer back on
        Output.Close() ' close the file
    End Sub
    Sub ClearInputBuffer()
        ' eg for running pip no need to display all the background information
        Dim BytesToRead As Integer
        If SerialPortFound = True Then
            Do
                If SerialPort.BytesToRead = 0 Then Exit Do ' no more bytes
                BytesToRead = SerialPort.BytesToRead
                If BytesToRead > 2000 Then BytesToRead = 2000
                SerialPort.Read(InPacket, 0, BytesToRead) ' read in a packet
            Loop
        End If
    End Sub
    Sub Get_CPM_Filename(ByRef Filenamepath As String, ByRef CPMFilename As String)
        ' send as byref to get the answer back
        ' pass c:\n8vem\mbasic\bascom.com and returns bascom.com
        ' start at the end and look for a \ character
        Dim i As Integer
        i = Strings.Len(Filenamepath)
        Do
            If Strings.Mid(Filenamepath, i, 1) = "\" Then Exit Do
            i = i - 1
        Loop
        CPMFilename = Strings.Mid(Filenamepath, i + 1)
    End Sub

    Private Sub FormatToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FormatToolStripMenuItem.Click
        Call FormatNew()
    End Sub
    Sub FormatNew()
        ' start with a blank disk
        Call StringToPacket(vbCrLf) ' hit enter to finish any half entered lines
        Call StringToPacket("B:" + vbCrLf)
        Sleep(300) ' wait to do it
        Call StringToPacket("FORMAT" + vbCrLf)
        Sleep(5000) ' takes about 1 sec at 8Mhz so 5 secs should be plenty
        Call StringToPacket("B:" + vbCrLf)
        Sleep(300) ' delay to do it
        Call XModemSend("C:\N8VEM\PIP.COM", True)
        Call StringToPacket("A:" + vbCrLf)
        Sleep(300) ' delay to do it
        Call StringToPacket("PIP A:XMODEM.COM=B:XMODEM.COM" + vbCrLf)
        Sleep(2000) ' delay to do it
        'Call SendBaudFiles() '1200 9600 and 38400
        'Call StringToPacket("38400" + vbCrLf)
        'SerialPort.BaudRate = "38400" ' 38400
        Call XModemSend("C:\N8VEM\XMODEMF.COM", True) ' fast version of xmodem (too fast for manual downloads)
        Call XModemFSend("C:\N8VEM\DIRX.COM", True)
        Call XModemFSend("C:\N8VEM\SUPERSUB.COM", True)
        Call XModemFSend("C:\N8VEM\AUTODIR.SUB", True)
        Call StringToPacket("REN AUTOEXEC.SUB=AUTODIR.SUB" + vbCrLf)
        Sleep(300) ' delay to do it
    End Sub

    Private Sub MBASICToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MBASICToolStripMenuItem.Click
        Call XModemFSend("C:\N8VEM\MBASIC.COM", True)
        Call XModemFSend("C:\N8VEM\BAS.SUB", True)
        Call XModemFSend("C:\N8VEM\BASCOM.COM", True)
        Call XModemFSend("C:\N8VEM\BASLIB.REL", True)
        Call XModemFSend("C:\N8VEM\BCLOAD", True)
        Call XModemFSend("C:\N8VEM\BRUN.COM", True)
        Call XModemFSend("C:\N8VEM\L80.COM", True)
    End Sub

    Private Sub WordstarToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles WordstarToolStripMenuItem.Click
        Call XModemFSend("C:\N8VEM\WS.COM", True)
        Call XModemFSend("C:\N8VEM\WS.OVR", True)
        Call XModemFSend("C:\N8VEM\WSMSGS.OVR", True)
    End Sub
    Private Sub KeyboardAnd20x4LCDToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles KeyboardAnd20x4LCDToolStripMenuItem.Click
        Call KeyboardLCD()
        Call StringToPacket("SUPERSUB AUTOEXEC" + vbCrLf)
        Sleep(300) ' delay to do it
    End Sub
    Sub KeyboardLCD()
        Call XModemFSend("C:\N8VEM\KEYBOARD.COM", True)
        Call XModemFSend("C:\N8VEM\LCD20X4.COM", True)
        Call XModemFSend("C:\N8VEM\LCDOFF.COM", True)
        Call XModemFSend("C:\N8VEM\AUTOKEY.SUB", True)
        Call XModemFSend("C:\N8VEM\KEYOFF.COM", True)
        Call StringToPacket("ERA AUTOEXEC.SUB" + vbCrLf)
        Sleep(300) ' delay to do it
        Call StringToPacket("REN AUTOEXEC.SUB=AUTOKEY.SUB" + vbCrLf)
        Sleep(300) ' delay to do it
    End Sub

    Sub StartScreen()
        Dim y As Integer
        Dim x As Integer
        For y = 0 To 41 ' line 41 is not displayed but useful for scrolling as a hidden line
            For x = 0 To 79
                Display(x, y) = " " ' clear display array to spaces
            Next
        Next
        Call RedrawDisplay()
        TextBox3.SelectionStart = 0 ' unhighlights the text
        Redrawing = True
    End Sub

    Sub SendCharacter(ByRef CharacterChanged As String)
        ' send to serial port - display it when it comes back
        If SerialPortFound = True Then
            OutPacket(0) = Asc(CharacterChanged) ' send as a byte through an array
            SerialPort.Write(OutPacket, 0, 1)
        End If
    End Sub
    Sub DisplayCharacter(ByRef CharacterChanged As String)
        ' receives a character from serial port and updates the display
        Dim x As Integer
        Dim y As Integer
        Dim a As Integer
        Dim i As Integer
        Dim DisplayString As String
        Dim asciichar As Integer
        Dim LineOfText As String
        If CursX > 79 Then CursX = 0 ' when listening to lots of ^ characters can error
        Static VT100 As String ' build vt100 string 
        asciichar = Strings.Asc(CharacterChanged)
        Select Case asciichar
            Case 13 ' carriage return - back to the left side but don't scroll
                CursX = 0
            Case 10 ' scroll up one line if on bottom line, otherwise just move down one
                If CursY < 40 Then
                    CursY = CursY + 1
                Else
                    For x = 0 To 79
                        Display(x, 41) = " " ' clear hidden line
                    Next
                    For y = 1 To 41
                        For x = 0 To 79
                            Display(x, y - 1) = Display(x, y)
                        Next
                    Next
                    CursY = 40
                End If
            Case 8 ' backspace
                CursX = CursX - 1
                If CursX < 0 Then CursX = 0
                Display(CursX, CursY) = " "
                If CursX < 0 Then CursX = 0
            Case 0, 28 To 31, 128 To 255 ' display binary values in curly braces
                DisplayString = "{" + Trim(Strings.Str(asciichar)) + "}"
                If CursX > 74 Then ' near end of line so new line
                    Call Scroll()
                End If
                For i = 1 To Len(DisplayString)
                    Display(CursX, CursY) = Strings.Mid(DisplayString, i, 1)
                    CursX = CursX + 1
                Next
            Case 1 To 7, 9, 11, 12, 14 To 26 ' display values 0 to 26 as ^
                If CursX > 74 Then ' near end of line so new line
                    Call Scroll()
                End If
                DisplayString = "^" + Strings.Chr(64 + asciichar) ' 1=^A 2=^B etc
                For i = 1 To Len(DisplayString)
                    Display(CursX, CursY) = Strings.Mid(DisplayString, i, 1)
                    CursX = CursX + 1
                Next
            Case 27 ' escape sequence
                VT100 = "]" ' start building vt100 string
        End Select
        ' no need to print character if >128 or a control character as already printed above
        If asciichar >= 32 And VT100 = "" And asciichar < 128 Then  ' ignore other characters under 32
            Display(CursX, CursY) = CharacterChanged
            CursX = CursX + 1 ' add one to the cursor
            If CursX > 79 Then
                CursX = 0
                CursY = CursY + 1 ' move to next line
            End If
            If CursY > 40 Then
                ' scroll up
                For x = 0 To 79
                    Display(x, 41) = " " ' clear hidden line
                Next
                For y = 1 To 41
                    For x = 0 To 79
                        Display(x, y - 1) = Display(x, y)
                    Next
                Next
                CursY = 40 ' beginning of last line
                CursX = 0
            End If
        End If
        ' vt100 escape codes - all start with ] which stands for escape (easier to match string)
        If VT100 <> "" And asciichar >= 32 Then
            VT100 = VT100 + CharacterChanged ' add new ones on
        End If
        If Strings.Len(VT100) > 40 Then ' some {instructions} can be at least 33 char
            VT100 = "" ' cancel it but this should never happen. Just gets it out of a potential hang
        End If
        If VT100 = "][H" Then
            ' home position
            CursX = 0
            CursY = 0
            Call RedrawDisplay()
            VT100 = "" ' reset it must do this for every command
        End If
        If VT100 = "][J" Then
            ' erase from current line to the bottom of the screen
            For y = CursY To 40
                For x = 0 To 79
                    Display(x, y) = " "
                Next
            Next
            Call RedrawDisplay()
            VT100 = "" ' reset it must do this for every command
        End If
        If VT100 = "][0m" Then
            ' reset all attributes - ignore
            VT100 = "" ' reset it must do this for every command
        End If
        If Strings.Len(VT100) >= 6 And Strings.Len(VT100) <= 8 And Strings.Right(VT100, 1) = "H" Then
            ' a cursor move instruction can be ][03;04H or ][3;4H or ][03;4H
            i = Strings.InStr(VT100, ";")
            If i <> 0 Then
                LineOfText = Strings.Left(VT100, i - 1)
                LineOfText = Strings.Mid(LineOfText, 3) ' strip off escape and [
                a = Val(LineOfText) ' row
                CursY = a - 1 ' I use origin of 0,0 and vt100 uses 1,1
                LineOfText = Strings.Mid(VT100, i + 1)
                LineOfText = Strings.Left(LineOfText, Strings.Len(LineOfText) - 1) ' strip off H
                a = Val(LineOfText) ' column
                CursX = a - 1
                Call RedrawDisplay()
            End If
            VT100 = "" ' reset it must do this for every command
        End If
        If VT100 = "][0;1m" Then ' highlight text
            ' highlight text but I'm not sure how to do this in a textbox (? a rich text box) 
            ' plus need to store this attribute in the array
            ' so just ignore for the moment
            VT100 = ""
        End If
        If VT100 = "][K" Or VT100 = "][0K" Then ' delete to the end of the line
            For x = CursX To 79
                Display(x, CursY) = " "
            Next
            Call RedrawDisplay()
            VT100 = "" ' reset it must do this for every command
        End If
        If VT100 = "][D" Then ' backspace ? a non documented vt100 code (escD is left arrow)
            'Only happens when opening a file and changing the name. 
            ' wordstar sends <esc>[D then a space then <esc>[D again
            CursX = CursX - 1
            If CursX < 0 Then CursX = 0
            Call RedrawDisplay()
            VT100 = "" ' reset it must do this for every command
        End If
        If VT100 = "][M" Then
            ' deletes the line with the cursor on it
            ' scrolls all lines below this up one
            For x = 0 To 79
                Display(x, y) = " "
            Next
            y = 41 ' delete hidden line
            For x = 0 To 79
                Display(x, y) = " "
            Next
            For y = CursY To 40
                For x = 0 To 79
                    Display(x, y) = Display(x, y + 1)
                Next
            Next
            Call RedrawDisplay()
            VT100 = "" ' reset it must do this for every command
        End If
        If VT100 = "][L" Then
            ' everything moves down one line from the current cursor line
            ' and delete the cursor line
            For y = 23 To CursY Step -1
                For x = 0 To 79
                    Display(x, y + 1) = Display(x, y)
                Next
            Next
            For x = 0 To 79
                Display(x, CursY) = " "
            Next
            Call RedrawDisplay()
            VT100 = "" ' reset it must do this for every command
        End If
        If VT100 = "][2J" Then
            ' clear the whole display and move cursor to home
            For y = 0 To 41
                For x = 0 To 79
                    Display(x, y) = " "
                Next
            Next
            CursX = 0
            CursY = 0
            Call RedrawDisplay()
            VT100 = "" 'reset it must do this for every command
        End If
        ' Televideo and Wyse commands for Pacman and tetris
        If VT100 = "];" Or VT100 = "]*" Then
            ' Televideo/Wyse60 command to clear screen ESC; or ESC*
            For y = 0 To 41
                For x = 0 To 79
                    Display(x, y) = " "
                Next
            Next
            CursX = 0
            CursY = 0
            Call RedrawDisplay()
            VT100 = "" 'reset it must do this for every command
        End If
        ' move cursor
        If Strings.Len(VT100) = 4 And Strings.Left(VT100, 2) = "]=" Then
            ' a cursor move instruction is ESC=RC,4 bytes 32 offset
            CursY = Strings.Asc(Strings.Mid(VT100, 3, 1)) - 32
            CursX = Strings.Asc(Strings.Mid(VT100, 4, 1)) - 32
            Call RedrawDisplay()
            VT100 = "" ' reset it must do this for every command
        End If
        ' cursor off
        If Strings.Len(VT100) > 2 And Strings.Left(VT100, 1) = "]" And Strings.Mid(VT100, 3, 1) <> "[" Then
            ' not a VT100 message as second character is not [
            If VT100 = "].0" Then
                ' cursor off
                VT100 = "" ' reset it must do this for every command
            End If
            If VT100 = "].1" Then
                ' cursor on
                VT100 = "" ' reset it must do this for every command
            End If
        End If
        ' don't forget to set vt100 to "" after every if vt100 statement
        ' now do the code for custom dir etc. Use ESC { which is not a valid vt100 code
        ' careful with recursiveness - eg if send anything out then will come back and start this sub again
        ' because even if turn off the timer, any xmodem send will turn it on again
        If VT100 <> "" And Strings.Mid(VT100, 2, 1) = "{" And Strings.Right(VT100, 1) = "}" Then
            ' special instruction eg <ESC>{DIR}
            ' can be of any length up to 20
            VT100 = Strings.UCase(VT100) ' capitals
            If Strings.Mid(VT100, 2, 5) = "{DIR}" Then
                ' send back all files in the C:\N8VEM directory
                Call SendDIRXmodem("*.*")
            End If
            If Strings.Mid(VT100, 2, 4) = "{DIR" And Strings.Len(VT100) > 7 Then
                ' eg {DIR *.COM} or {DIR *.*}
                LineOfText = Strings.Mid(VT100, 7) ' from after the space
                LineOfText = Strings.Left(LineOfText, Strings.Len(LineOfText) - 1) ' strip off the trailing }
                Call SendDIRXmodem(LineOfText)
            End If
            ' ... test for other special commands
            If Strings.Mid(VT100, 2, 4) = "{PIP" Then
                Call Pip(VT100)
            End If
            If Strings.Mid(VT100, 2, 4) = "{ERA" Then
                Call Era(VT100)
            End If
            If Strings.Mid(VT100, 2, 5) = "{STAT" Then
                Call Stat()
            End If
            VT100 = "" ' finished
        End If
        ' do not put a redraw display here - slows down code++
    End Sub
    Sub Scroll()
        ' scroll the line and insert a new line
        Dim x As Integer
        Dim y As Integer
        CursX = 0
        If CursY < 40 Then
            CursY = CursY + 1
        Else
            For x = 0 To 79
                Display(x, 41) = " " ' clear hidden line
            Next
            For y = 1 To 41
                For x = 0 To 79
                    Display(x, y - 1) = Display(x, y)
                Next
            Next
            CursY = 40
        End If

    End Sub
    Sub SendDIRXmodem(ByRef Extension As String)
        ' experiment with either sending text directly, or dumping to a text file and sending via xmodem
        ' only problem here is mbasic can't chain .com programs esp supersub
        ' so how do you get mbasic to run xmodem?
        ' maybe poke to the supersub location in cp/m
        ' or maybe this program sends a SYSTEM to the board
        ' then runs xmodem
        ' then restarts P - yes this works well. 
        Dim strFileSize As String = ""
        Dim di As New IO.DirectoryInfo("C:\N8VEM")
        Dim aryFi As IO.FileInfo() = di.GetFiles(Extension)
        Dim fi As IO.FileInfo
        Dim SingleLine As String
        Dim LineOfText As String
        Dim Counter As Integer ' count 0,1,2,3 then back to 0
        Dim Ext As String
        Dim Filename As String
        FileOpen(1, "C:\N8VEM\ToN8VEM.txt", OpenMode.Output) ' open a file
        SingleLine = "P: "
        For Each fi In aryFi
            strFileSize = (Math.Round(fi.Length / 1024)).ToString()
            LineOfText = fi.Name ' name
            LineOfText = UCase(LineOfText) ' convert to upper case so looks like CP/M
            Ext = Strings.Right(LineOfText, 3) ' extension
            Filename = Strings.Left(LineOfText, Strings.Len(LineOfText) - 4)
            Filename = Filename + "         "
            Filename = Strings.Left(Filename, 9) ' pad so 9 characters long
            SingleLine = SingleLine + Filename + Ext
            If Counter < 3 Then
                SingleLine = SingleLine + " : " ' not for last entry
            End If
            Counter = Counter + 1
            If Counter = 4 Then
                PrintLine(1, SingleLine)
                ' send out the line, no need for delays. COMMS is expecting this
                Counter = 0
                SingleLine = "P: " ' start new line
            End If
            'MsgBox("File Size (KB): {0}", strFileSize)
            'MsgBox("File Extension: {0}", fi.Extension)
            'Console.WriteLine("Last Accessed: {0}", fi.LastAccessTime)
            'Console.WriteLine("Read Only: {0}", (fi.Attributes.ReadOnly = True).ToString)
        Next
        ' will have a partly completed line here so save this
        SingleLine = Strings.Left(SingleLine, Strings.Len(SingleLine) - 3) ' trim off the last :
        PrintLine(1, SingleLine)
        FileClose(1)
        Sleep(500) ' wait till comms ends and goes back to cp/m
        Call ClearInputBuffer()
        Call XModemSend("C:\N8VEM\ToN8VEM.txt", False) ' timer stays off
        Sleep(200)
        Call ClearInputBuffer()
        Call StringToPacket("P" + vbCrLf) ' Restart the P program
    End Sub
    Sub Pip(ByRef Lineoftext As String)
        ' pass something like ]{PIP A:MYFILE.TXT=P:MYFILE.TXT}
        ' or PIP A:*.BAS=P:*.BAS"
        Dim FromDrive As String
        Dim ToDrive As String
        Dim i As Integer
        Dim Instruction As String
        Dim Filename As String
        Dim strFileSize As String = ""
        Dim di As New IO.DirectoryInfo("C:\N8VEM")
        Dim fi As IO.FileInfo
        Instruction = Strings.Mid(Lineoftext, 3) ' remove ]{ at beginning
        Instruction = Strings.Left(Instruction, Strings.Len(Instruction) - 1) ' remove trailing }
        ' now is PIP A:MYFILE.TXT=P:MYFILE.TXT or PIP A:*.COM=P:*.COM
        ToDrive = Strings.Mid(Instruction, 5, 2)
        i = Strings.InStr(Instruction, "=")
        Filename = Strings.Mid(Instruction, i + 3)
        FromDrive = Strings.Mid(Instruction, i + 1, 2)
        Sleep(500) ' wait for comms to finish
        If FromDrive = "P:" Then
            ' copy from PC to N8VEM
            If Strings.Left(Filename, 1) = "*" Then
                Dim aryFi As IO.FileInfo() = di.GetFiles(Filename) ' filename=eg *.COM
                For Each fi In aryFi
                    Lineoftext = fi.Name ' name
                    Lineoftext = UCase(Lineoftext) ' convert to upper case so looks like CP/M
                    Filename = "C:\N8VEM\" + Lineoftext
                    Call XModemSend(Filename, False) ' timer stays off
                    Call ClearInputBuffer()
                Next
                Sleep(200)
                Call StringToPacket("P" + vbCrLf)
                ' multiple files
            Else
                'just one file
                Filename = "C:\N8VEM\" + Filename ' add the local directory
                Call XModemSend(Filename, False) ' timer stays off
                Sleep(200)
                Call ClearInputBuffer()
                Call StringToPacket("P" + vbCrLf) ' Restart the P program
            End If

        End If
        If FromDrive = "A:" Then
            If Strings.Left(Filename, 1) = "*" Then
                'copy from N8VEM to PC
                ' multiple files not coded yet because need to get a list of the files
                ' off the n8vem and that is a bit tricky
                ' maybe do a dir and capture it?
            Else
                ' single file
                Filename = "C:\N8VEM\" + Filename ' add the local directory
                Call XModemReceive(Filename, False) ' timer stays off
                Sleep(200)
                Call ClearInputBuffer()
                Call StringToPacket("P" + vbCrLf) ' Restart the P program
            End If
        End If
    End Sub
    Sub Era(ByRef Lineoftext As String)
        ' pass ERA FILENAME.EXT 
        ' ERA *.* not supported as could wipe out lots of useful files on the PC
        ' but can easily add it
        ' in fact it may well work with kill below but not actually tested
        Dim Instruction As String
        Instruction = Strings.Mid(Lineoftext, 3) ' remove ]{ at beginning
        Instruction = Strings.Left(Instruction, Strings.Len(Instruction) - 1) ' remove trailing }
        ' now is ERA FILENAME.EXT
        Instruction = Strings.Mid(Instruction, 5) ' trim off the ERA
        If Strings.Left(Instruction, 1) <> "*" Then ' deliberately stop *.* or *.EXT
            Kill("C:\N8VEM\" + Instruction) ' good to see an old MBASIC instruction still in .net
        End If
        Sleep(200)
        Call ClearInputBuffer()
        Call StringToPacket("P" + vbCrLf) ' Restart the P program
    End Sub
    Sub Stat()
        ' no variables passed but maybe down the track could do stat *.* and print file sizes
        'MsgBox("Free Space on C: " & GetFreeSpace("C:\") & "MB")
        Dim Lineoftext As String
        Lineoftext = "P: R/W  Space: " & GetFreeSpace("C:\") & "MB"
        FileOpen(1, "C:\N8VEM\ToN8VEM.txt", OpenMode.Output) ' open a file
        PrintLine(1, Lineoftext)
        FileClose(1)
        Sleep(500) ' wait till comms ends and goes back to cp/m
        Call ClearInputBuffer()
        Call XModemSend("C:\N8VEM\ToN8VEM.txt", False) ' timer stays off
        Sleep(200)
        Call ClearInputBuffer()
        Call StringToPacket("STAT" + vbCrLf) ' stat the A drive
        Call StringToPacket("P" + vbCrLf) ' Restart the P program, will print the P drive stat
    End Sub
    Sub RedrawDisplay()
        Dim y As Integer
        Dim x As Integer
        Dim Textstring As String
        Dim CursorPosition As Integer
        Redrawing = False ' so textboxchanged doesn't keep being called
        For y = 0 To 40
            For x = 0 To 79
                Textstring = Textstring + Display(x, y)
            Next
            Textstring = Textstring + vbCrLf
        Next
        TextBox3.Text = Textstring
        CursorPosition = CursY * 82 + CursX ' 82 because of the CR and LF
        TextBox3.SelectionStart = CursorPosition
        Redrawing = True
        OldCursorPos = CursorPosition
        System.Windows.Forms.Application.DoEvents() ' update the display
    End Sub
    Private Sub TextBox3_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox3.KeyPress
        ' must use keypress to get the ascii value, not keydown (which gives the keyboard scan value and doesn't distinguish between smalls and caps)
        Dim c As String
        Dim asciichar As String
        c = e.KeyChar.ToString
        REM If Radio1200 = False Then
        OutPacket(0) = Asc(c) ' send as a byte through an array
        If SerialPortFound = True Then
            SerialPort.Write(OutPacket, 0, 1)
        End If
    End Sub
    Sub StoreKeyPress(ByRef SingleCharacter As String)
        ' store and forward. Also if a counter Keycounter gets to 1 sec then send anyway
        ' disabled for the moment see above
        Static Buff1200 As String
        Dim i As Integer
        If SingleCharacter = "" Then
            'called from timer - force a send of all the buffer
            If Buff1200 <> "" Then
                For i = 1 To Strings.Len(Buff1200)
                    OutPacket(0) = Asc(Strings.Mid(Buff1200, i, 1)) ' send as a byte through an array
                    If SerialPortFound = True Then
                        SerialPort.Write(OutPacket, 0, 1)
                    End If
                Next
            End If
            Buff1200 = ""
        Else
            KeyCounter = 0 ' reset it 
            Select Case Asc(SingleCharacter)
                ' maybe need to handle 10??
                Case 13
                    For i = 1 To Strings.Len(Buff1200)
                        OutPacket(0) = Asc(Strings.Mid(Buff1200, i, 1)) ' send as a byte through an array
                        If SerialPortFound = True Then
                            SerialPort.Write(OutPacket, 0, 1)
                        End If
                    Next
                    Buff1200 = ""
                    OutPacket(0) = 13 ' send as a byte through an array
                    If SerialPortFound = True Then
                        SerialPort.Write(OutPacket, 0, 1)
                    End If
                Case Else
                    Buff1200 = Buff1200 + SingleCharacter
            End Select
        End If
    End Sub
    Private Declare Function GetDiskFreeSpaceEx Lib "kernel32" Alias "GetDiskFreeSpaceExA" (ByVal lpDirectoryName As String, ByRef lpFreeBytesAvailableToCaller As Long, ByRef lpTotalNumberOfBytes As Long, ByRef lpTotalNumberOfFreeBytes As Long) As Long
    Public Function GetFreeSpace(ByVal Drive As String) As Long
        'returns free space in MB, formatted to two decimal places
        'e.g., msgbox("Free Space on C: "& GetFreeSpace("C:\") & "MB")
        Dim lBytesTotal, lFreeBytes, lFreeBytesAvailable As Long
        Dim iAns As Long
        iAns = GetDiskFreeSpaceEx(Drive, lFreeBytesAvailable, lBytesTotal, lFreeBytes)
        If iAns > 0 Then
            Return BytesToMegabytes(lFreeBytes)
        Else
            Throw New Exception("Invalid or unreadable drive")
        End If
    End Function
    Private Function BytesToMegabytes(ByVal Bytes As Long) As Long
        Dim dblAns As Double
        dblAns = (Bytes / 1024) / 1024
        BytesToMegabytes = Format(dblAns, "###,###,##0.00")
    End Function
    Private Sub OnToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OnToolStripMenuItem.Click
        CaptureFlag = True
        MsgBox("File captured in c:\n8vem\capture.txt (rename as .bin to view hidden characters)")
    End Sub
    Private Sub OffToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OffToolStripMenuItem.Click
        CaptureFlag = False
    End Sub
    Sub CaptureText(ByRef lineoftext As String)
        Dim i As Integer
        Dim c As String
        FileOpen(2, "c:\n8vem\capture.txt", OpenMode.Append) ' open a file
        For i = 1 To Strings.Len(lineoftext)
            c = Strings.Mid(lineoftext, i, 1)
            Print(2, c)
        Next
        FileClose(2)
    End Sub

    Sub SendBaudFiles()
        Call XModemFSend("C:\N8VEM\50.COM", True)
        Call XModemFSend("C:\N8VEM\300.COM", True)
        Call XModemFSend("C:\N8VEM\1200.COM", True)
        Call XModemFSend("C:\N8VEM\9600.COM", True)
        Call XModemFSend("C:\N8VEM\19200.COM", True)
        Call XModemFSend("C:\N8VEM\38400.COM", True)
        Call XModemFSend("C:\N8VEM\115200.COM", True)
    End Sub


    Private Sub BufferAndSendfor1200ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If SerialPortFound = True Then
            SerialPort.BaudRate = "1200" ' 1200
            TypematicSlow = True
        End If
    End Sub

    Private Sub BufferAndSendOFFToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        TypematicSlow = False
    End Sub

    Private Sub ToolStripMenuItem5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItem5.Click
        Call StringToPacket("1200" + vbCrLf)
        If SerialPortFound = True Then
            SerialPort.BaudRate = "1200" ' 1200
        End If
        Sleep(300) ' delay to do it
        Call StringToPacket(vbCrLf)
    End Sub

    Private Sub ToolStripMenuItem6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItem6.Click
        TypematicSlow = False
        Call StringToPacket("4800" + vbCrLf)
        If SerialPortFound = True Then
            SerialPort.BaudRate = "4800"
        End If
        Sleep(300) ' delay to do it
        Call StringToPacket(vbCrLf)
    End Sub

    Private Sub ToolStripMenuItem7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItem7.Click
        TypematicSlow = False
        Call StringToPacket("9600" + vbCrLf)
        If SerialPortFound = True Then
            SerialPort.BaudRate = "9600"
        End If
        Sleep(300) ' delay to do it
        Call StringToPacket(vbCrLf)
    End Sub

    Private Sub Radio1200AndONToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Radio1200AndONToolStripMenuItem.Click
        Call EchoOff1200()
    End Sub
    Sub EchoOff1200()
        Call StringToPacket("1200" + vbCr)
        Sleep(300) ' delay to do it
        If SerialPortFound = True Then
            SerialPort.BaudRate = "1200" ' 1200
        End If
        Call StringToPacket(vbCr)
        EchoOn = False
        Call StringToPacket("EchoOff" + vbCr)
        TypematicSlow = True ' very slow typematic speed
        TextBox3.Focus()
    End Sub

    Private Sub AndOFFToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AndOFFToolStripMenuItem.Click
        Call StringToPacket("38400" + vbCrLf)
        If SerialPortFound = True Then
            SerialPort.BaudRate = "38400" ' 38400
        End If
        Sleep(300) ' delay to do it
        Call StringToPacket(vbCrLf)
        TypematicSlow = False ' faster typematic speed
        TextBox3.Focus()
    End Sub

    Private Sub AssemblyToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AssemblyToolStripMenuItem.Click
        Call XModemFSend("C:\N8VEM\L80.COM", True)
        Call XModemFSend("C:\N8VEM\M80.COM", True)
        Call XModemFSend("C:\N8VEM\ZASM.SUB", True)
        Call XModemFSend("C:\N8VEM\ASSMBLYM.TXT", True)
    End Sub

    Private Sub AssemblyASMToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AssemblyASMToolStripMenuItem.Click
        Call XModemFSend("C:\N8VEM\ASM.COM", True)
        Call XModemFSend("C:\N8VEM\LOAD.COM", True)
        Call XModemFSend("C:\N8VEM\ASM.SUB", True)
        Call XModemFSend("C:\N8VEM\ASSEMBLY.TXT", True)
    End Sub

    Private Sub SBASICToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SBASICToolStripMenuItem.Click
        Call Sbasic()
    End Sub
    Sub Sbasic()
        Call XModemFSend("C:\N8VEM\SBASIC.COM", True)
        Call XModemFSend("C:\N8VEM\OVERLAYB.COM", True)
        Call XModemFSend("C:\N8VEM\BASICLIB.REL", True)
        Call XModemFSend("C:\N8VEM\USERLIB.REL", True)
    End Sub


    Private Sub CompileToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Call CompileN8VEM()
    End Sub
    Sub CompileN8VEM()
        ' assumes sbasic files already downloaded
        Dim NoExtension As String
        TabControl1.SelectedIndex = 0 ' to tab 0
        Call SaveSbasicFile()
        NoExtension = Strings.Left(SbasicFile, Len(SbasicFile) - 4)
        Call XModemSend("C:\N8VEM\" + SbasicFile, True)
        Call StringToPacket("SBASIC " + NoExtension + vbCrLf)
        TabControl1.SelectedIndex = 0 ' display cp/m
        TextBox3.Focus() 'display to cp/m
    End Sub
    Private Sub SaveToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Call SaveSbasicFile()
    End Sub
    Sub SaveSbasicFile()
        If SbasicFile = "" Then
            SbasicFile = InputBox("Filename eg MYFILE.BAS: ", , SbasicFile)
            Label5.Text = SbasicFile
        End If
        RichTextBox1.SaveFile("C:\N8VEM\" + SbasicFile, RichTextBoxStreamType.PlainText)
        RichTextBox1.Focus()
        SbasicChanged = False
    End Sub
    Private Sub NewToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Call NewSbasic()
    End Sub
    Sub NewSbasic()
        SbasicFile = "NEW.BAS"
        SbasicFile = InputBox("Filename eg MYFILE.BAS (no more than 8 characters):", , SbasicFile)
        SbasicFile = Strings.UCase(SbasicFile)
        Label5.Text = SbasicFile
        RichTextBox1.Text = ""
        RichTextBox1.AppendText("comment" + vbLf + vbTab + "call small procedures first then bigger procedures" + vbLf + vbTab + "as can't call/reference a later procedure (one pass compiler)" + vbLf + vbTab + "Dim common variables eg arrays at beginning of program" + vbLf + "end" + vbLf)
        RichTextBox1.AppendText("rem *** functions and procedures ***" + vbLf + vbLf)
        RichTextBox1.AppendText("rem ************ MAIN **************" + vbLf + vbLf)
        RichTextBox1.AppendText("print " + Chr(34) + "Hello World" + Chr(34) + vbLf)
        RichTextBox1.AppendText("end" + vbLf)
        Call ColorSbasic()
        TabControl1.SelectedIndex = 1
        RichTextBox1.Focus()
    End Sub
    Private Sub OpenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Call OpenSbasic()
    End Sub
    Sub OpenSbasic()
        Dim Filepath As String
        Filepath = "c:\N8VEM"
        OpenFileDialog1.Multiselect = False
        OpenFileDialog1.InitialDirectory = Filepath
        OpenFileDialog1.FileName = "*.BAS"
        OpenFileDialog1.ShowDialog()
        SbasicFile = OpenFileDialog1.FileName
        SbasicFile = Strings.Mid(SbasicFile, 10) ' strip off directory
        SbasicFile = Strings.UCase(SbasicFile)
        Label5.Text = SbasicFile
        Try
            RichTextBox1.LoadFile("C:\N8VEM\" + SbasicFile, RichTextBoxStreamType.PlainText)
            TabControl1.SelectedIndex = 1
            RichTextBox1.Focus()
            If RichTextBox1.TextLength < 5000 Then
                Call ColorSbasic() ' no color for big files as takes ages to load
                ColorOn = True
            Else
                ColorOn = False
            End If
        Catch ex As Exception
            ' user probably hit cancel
        End Try
    End Sub
    Private Sub RichTextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RichTextBox1.TextChanged
        SbasicRedraw = 0 ' reset it each keypress - if no activity for 5 secs then redraw
        SbasicChanged = True
    End Sub
    Sub ColorSbasic()
        Dim Greenwords As New List(Of String)
        Dim Bluewords As New List(Of String)
        Dim Goldwords As New List(Of String) ' syntax errors
        Greenwords.Add("rem")
        ' purple words
        Goldwords.Add(" as ") ' should use =
        ' blue words
        Bluewords.Add("abs(")
        Bluewords.Add(" and ")
        Bluewords.Add("atn(")
        'Bluewords.Add("base")
        Bluewords.Add("begin")
        Bluewords.Add("call ")
        Bluewords.Add("case ")
        Bluewords.Add("chain ")
        Bluewords.Add("chr$(")
        Bluewords.Add("close ")
        'Bluewords.Add("com")
        Bluewords.Add("comment")
        Bluewords.Add("cos(")
        'Bluewords.Add("create")
        Bluewords.Add("data ")
        Bluewords.Add("delete ")
        Bluewords.Add("dim ")
        Bluewords.Add(" do")
        Bluewords.Add("else")
        Bluewords.Add("end")
        'Bluewords.Add("eqv")
        'Bluewords.Add("execute")
        Bluewords.Add("exp")
        Bluewords.Add("fcb")
        Bluewords.Add("files")
        Bluewords.Add("fint")
        Bluewords.Add("for ")
        Bluewords.Add("fre(")
        Bluewords.Add("function ")
        Bluewords.Add("gosub ")
        Bluewords.Add("goto ")
        Bluewords.Add("hex$(")
        Bluewords.Add("if ")
        'Bluewords.Add("imp")
        Bluewords.Add("input ")
        Bluewords.Add("instr(")
        Bluewords.Add("int(")
        Bluewords.Add("left$(")
        Bluewords.Add("left(")
        Bluewords.Add("len(")
        Bluewords.Add("let ")
        'Bluewords.Add("locate")
        Bluewords.Add("log(")
        Bluewords.Add("mid(")
        Bluewords.Add("mid$(")
        Bluewords.Add("next ")
        Bluewords.Add("not ")
        Bluewords.Add("num$(")
        Bluewords.Add("of ")
        'Bluewords.Add("on ")
        Bluewords.Add("open ")
        Bluewords.Add("or ")
        Bluewords.Add("out ")
        Bluewords.Add("peek(")
        Bluewords.Add("poke ")
        Bluewords.Add("print ")
        Bluewords.Add("procedure ")
        'Bluewords.Add("read")
        'Bluewords.Add("rename")
        Bluewords.Add("repeat")
        Bluewords.Add("restore")
        'Bluewords.Add("ret")
        Bluewords.Add("return" + vbLf)
        Bluewords.Add("right(")
        Bluewords.Add("right$(")
        Bluewords.Add("rnd(")
        Bluewords.Add("sgn(")
        Bluewords.Add("sin(")
        'Bluewords.Add("size")
        Bluewords.Add("space$(")
        'Bluewords.Add("spc")
        Bluewords.Add("sqr(")
        Bluewords.Add("step ")
        'Bluewords.Add("stop")
        Bluewords.Add("str$(")
        Bluewords.Add("string(")
        Bluewords.Add("string$(")
        'Bluewords.Add("sub")
        'Bluewords.Add("tab")
        Bluewords.Add("tan(")
        'Bluewords.Add("text ")
        Bluewords.Add("then ")
        Bluewords.Add("to ")
        Bluewords.Add("until ")
        Bluewords.Add("var ")
        'Bluewords.Add("variable")
        Bluewords.Add("while ")
        Bluewords.Add("write ")
        'Bluewords.Add("xlate")
        Bluewords.Add("xor ")
        Dim i As Integer
        Dim GreenFlag As Boolean
        Dim TempString As String
        Dim L As Integer
        Dim RemFlag As Boolean
        Dim QuoteFlag As Boolean
        Dim QuoteCount As Integer
        If RichTextBox1.Text.Length > 0 And ColorOn = True Then
            SendMessage(RichTextBox1.Handle, WM_SETREDRAW, New IntPtr(CInt(False)), IntPtr.Zero) ' disable refresh
            Dim selectStart As Integer = RichTextBox1.SelectionStart ' preserve cursor
            RichTextBox1.Select(0, RichTextBox1.Text.Length)
            RichTextBox1.SelectionColor = Color.Black
            RichTextBox1.DeselectAll()
            'do blue words
            For Each oneWord As String In Bluewords
                Dim pos As Integer = 0
                Do While RichTextBox1.Text.ToUpper.IndexOf(oneWord.ToUpper, pos) >= 0
                    pos = RichTextBox1.Text.ToUpper.IndexOf(oneWord.ToUpper, pos)
                    RichTextBox1.Select(pos, oneWord.Length)
                    RichTextBox1.SelectionColor = Color.Blue
                    pos = pos + 1
                Loop
            Next
            'do purple words (syntax errors eg using as instead of = because vb.net uses as
            For Each oneWord As String In Goldwords
                Dim pos As Integer = 0
                Do While RichTextBox1.Text.ToUpper.IndexOf(oneWord.ToUpper, pos) >= 0
                    pos = RichTextBox1.Text.ToUpper.IndexOf(oneWord.ToUpper, pos)
                    RichTextBox1.Select(pos, oneWord.Length)
                    RichTextBox1.SelectionColor = Color.Gold
                    pos = pos + 1
                Loop
            Next
            ' put in rem and comments in green. 10 is end of line
            GreenFlag = False
            TempString = LCase(RichTextBox1.Text) ' all lower case for matching
            L = Strings.Len(TempString)
            For i = 1 To L
                If i > 8 Then 'not too near the beginning
                    If Strings.Mid(TempString, i - 8, 8) = "comment" + vbLf Then
                        GreenFlag = True
                    End If
                End If
                If i < L - 3 Then ' not too near the end
                    If Strings.Mid(TempString, i, 4) = vbLf + "end" Then
                        GreenFlag = False
                    End If
                End If
                If Strings.Mid(TempString, i, 3) = "rem" Then ' rem to end of line
                    RemFlag = True
                    GreenFlag = True
                End If
                If RemFlag = True And Strings.Mid(TempString, i, 1) = vbLf Then
                    RemFlag = False
                    GreenFlag = False
                End If
                If Strings.Mid(TempString, i, 1) = Strings.Chr(34) Then
                    QuoteFlag = True
                End If
                If i > 2 And QuoteCount > 1 Then
                    If QuoteFlag = True And Strings.Mid(TempString, i - 1, 1) = Strings.Chr(34) Then
                        QuoteFlag = False
                        QuoteCount = 0
                    End If
                End If
                If GreenFlag = True Then
                    RichTextBox1.Select(i - 1, 1)
                    RichTextBox1.SelectionColor = Color.Green
                End If
                If QuoteFlag = True Then QuoteCount = QuoteCount + 1
                If QuoteFlag = True Then ' add red text last, overwrites green and blue in quotes
                    RichTextBox1.Select(i - 1, 1)
                    RichTextBox1.SelectionColor = Color.Red
                End If
            Next
            RichTextBox1.SelectionStart = selectStart
            RichTextBox1.SelectionLength = 0
            SbasicRedraw = -1 ' disable counter till next keypress
            SendMessage(RichTextBox1.Handle, WM_SETREDRAW, New IntPtr(CInt(True)), IntPtr.Zero)
            RichTextBox1.Refresh()
        End If
    End Sub
    Sub LoadSbasicLibrary()
        Dim storefile As Directory
        Dim directory As String
        Dim files As String()
        Dim File As String
        Dim NameOnly As String
        ComboBoxEnable = False
        Try
            files = storefile.GetFiles("C:\N8VEM", "*.SBA")
            For Each File In files
                NameOnly = Strings.Mid(File, 10)
                'NameOnly = Strings.Left(NameOnly, Strings.Len(NameOnly) - 4) ' strip off .sba
                ComboBox1.Items.Add(NameOnly)
            Next
            ComboBox1.Text = ComboBox1.Items(0)
        Catch ex As Exception
            ' eg if no files present
        End Try
        ComboBoxEnable = True
    End Sub
    Private Sub Button17_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button17.Click
        Dim tempstring As String
        Dim Filename As String
        Dim i As Integer
        tempstring = RichTextBox1.Text
        i = RichTextBox1.SelectionStart
        Filename = "C:\N8VEM\" + ComboBox1.Text
        RichTextBox2.LoadFile(Filename, RichTextBoxStreamType.PlainText) ' one line fileload!!
        tempstring = Strings.Left(tempstring, i) + RichTextBox2.Text + Strings.Mid(tempstring, i + 1)
        RichTextBox1.Text = tempstring
        Call ColorSbasic() ' color it in
    End Sub

    Private Sub SaveToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Call SaveAsSbasic()
    End Sub
    Sub SaveAsSbasic()
        Dim Filenamepath As String
        Dim Filepath As String
        Filepath = "c:\N8VEM"
        SaveFileDialog1.InitialDirectory = Filepath
        SaveFileDialog1.FileName = SbasicFile ' ? put CPM files somewhere safe
        SaveFileDialog1.ShowDialog()
        Filenamepath = SaveFileDialog1.FileName
        Try
            RichTextBox1.SaveFile(Filenamepath, RichTextBoxStreamType.PlainText)
            SbasicFile = Strings.Mid(Filenamepath, 10)
            Label5.Text = SbasicFile
            RichTextBox1.Focus()
        Catch ex As Exception
            're user probably hit cancel
        End Try
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        If ColorOn = False Then
            ColorOn = True
            Button1.Text = "Color Off"
            Call ColorSbasic()
        Else
            ColorOn = False
            Button1.Text = "Color On"
            Dim selectStart As Integer = RichTextBox1.SelectionStart ' preserve cursor
            RichTextBox1.Select(0, RichTextBox1.Text.Length)
            RichTextBox1.SelectionColor = Color.Black
            RichTextBox1.SelectionStart = selectStart
            RichTextBox1.SelectionLength = 0
        End If
    End Sub

    Private Sub DocumentationToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    End Sub
    Sub HelpSbasic()
        ColorOn = False ' if color was on then turn it off
        Button1.Text = "Color On"
        If SbasicFile <> "" Then
            Call SaveSbasicFile()
        End If
        RichTextBox1.Clear()
        RichTextBox1.LoadFile("C:\N8VEM\SBEntire.txt", RichTextBoxStreamType.PlainText)
        TabControl1.SelectedIndex = 1
        RichTextBox1.Focus()
    End Sub
    Private Sub NewBoardProgramAndNameToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NewBoardProgramAndNameToolStripMenuItem.Click
        Dim BoardName As String
        BoardName = InputBox("Board name (1 to 8 characters): ", , )
        FileOpen(1, "C:\N8VEM\MYNAME.TXT", OpenMode.Output) ' open a file
        PrintLine(1, BoardName)
        FileClose(1)
        Call FormatNew()
        Call KeyboardLCD()
        Call StringToPacket("LCD20X4" + vbCr)
        Sleep(300) ' delay to do it
        Call XModemSend("C:\N8VEM\AUTORAD.SUB", True) ' radio runs 1200 as well
        Call StringToPacket("ERA AUTOEXEC.SUB" + vbCr)
        Sleep(300) ' delay to do it
        Call StringToPacket("REN AUTOEXEC.SUB=AUTORAD.SUB" + vbCr)
        Sleep(300) ' delay to do it
        Call XModemSend("C:\N8VEM\MYNAME.TXT", True)
        Call XModemSend("C:\N8VEM\1200.COM", True)
        Call XModemSend("C:\N8VEM\38400.COM", True)
        Call XModemSend("C:\N8VEM\ECHOOFF.COM", True)   ' echo off used for radio silence
        Call XModemSend("C:\N8VEM\ECHOON.COM", True)
        Call XModemSend("C:\N8VEM\NAMEME.COM", True)
        Call XModemSend("C:\N8VEM\REPEATER.COM", True)
        Call XModemSend("C:\N8VEM\DIRLST2.COM", True)
        Sleep(300)
        Call StringToPacket("SUPERSUB AUTOEXEC" + vbCr) ' rerun the autoexec to get 1200
        Sleep(300)
        If SerialPortFound = True Then
            SerialPort.BaudRate = "1200" ' 1200
        End If
        'Radio1200 = True ' buffers text before sending
        MsgBox("Now communicating at 1200 baud and Echo is off")
        TextBox3.Focus()
    End Sub



    Private Sub CompileUsingSIMHToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Call CompileSIMHN8VEM("Send")
    End Sub
    Sub CompileSIMHN8VEM(ByVal Download As String)
        Dim Location As New Process
        Dim Filename1 As String
        Dim i As Integer
        Try
            Call SaveSbasicFile()
            TextBox1.Text = ""
            TextBox1.Refresh()
            Filename1 = Strings.Left(SbasicFile, Len(SbasicFile) - 4)
            FileCopy("C:\N8VEM\" + Filename1 + ".BAS", "C:\N8VEM\AltairSIMH\" + Filename1 + ".BAS")
            Location.StartInfo.FileName = "AltairAllTelnet.bat"
            Location.StartInfo.WorkingDirectory = "C:\n8vem\AltairSIMH"
            Location.Start() ' shell the batch file
            w3sock.TimeOut = 5000 ' long enough to do a compile for a big program?
            w3sock.DoTelnetEmulation = True
            w3sock.TelnetEmulation = "TTY"
            w3sock.Host = "Localhost:23"
            w3sock.Open()
            w3sock.WaitFor(">")
            w3sock.SendText("D:" + vbCrLf) ' change to drive D where sbasic is
            Sleep(200)
            w3sock.WaitFor(">")
            w3sock.SendText("R " + Filename1 + ".BAS" + vbCrLf) ' copy to the simh from pc directory
            Sleep(200)
            w3sock.WaitFor(">")
            w3sock.SendText("SBASIC " + Filename1 + vbCrLf) ' run sbasic
            Sleep(100) ' will take longer than this
            w3sock.WaitFor("D>") ' wait for the D> prompt to come back
            Call RefreshTextBox1() ' display error messages etc as they come in
            For i = 1 To 2
                w3sock.SendText(vbCrLf) ' in case hangs send a few CRs
                Sleep(200)
                w3sock.WaitFor(">")
            Next
            w3sock.SendText("W " + Filename1 + ".COM" + vbCrLf) ' write back to PC directory
            Sleep(100)
            w3sock.WaitFor(">")
            RefreshTextBox1()
            For i = 1 To 2
                w3sock.SendText(vbCrLf) ' in case hangs send a couple of CRs
                Sleep(100)
                w3sock.WaitFor(">")
            Next
            ' erase the files on the simh otherwise fill up the 1mb disk image
            w3sock.SendText("ERA " + Filename1 + ".BAS" + vbCrLf) ' so don't clutter up simulated drive D
            Sleep(100)
            w3sock.WaitFor(">")
            Call RefreshTextBox1()
            w3sock.SendText("ERA " + Filename1 + ".COM" + vbCrLf)
            Sleep(100)
            w3sock.WaitFor(">")
            'now halt the simh program
            w3sock.SendText("HALT" + vbCrLf) ' halt the simh
            Call RefreshTextBox1()
            ' now copy file to c:\N8VEM
            FileCopy("C:\N8VEM\AltairSIMH\" + Filename1 + ".COM", "C:\N8VEM\" + Filename1 + ".COM")
            Kill("C:\N8VEM\AltairSIMH\" + Filename1 + ".BAS") ' clean up
            Kill("C:\N8VEM\AltairSIMH\" + Filename1 + ".COM") ' clean up
            ' and transfer it to the board
            w3sock.Close() ' close the socket
            If Download = "Send" Then
                TabControl1.SelectedIndex = 0 ' to tab 0
                TextBox3.Focus() ' focus to cp/m window
                System.Windows.Forms.Application.DoEvents() ' update the display
                Call XModemFSend("C:\N8VEM\" + Filename1 + ".COM", True)
            End If
            ' and try running it
            ' disable running it for the moment
            'Call StringToPacket(Filename1 + vbCrLf)
        Catch ex As Exception
            ' errors eg if it didn't compile so there is no file to copy
            w3sock.Close() ' close the socket
            TextBox1.Text += vbCrLf + "Syntax error - aborting" + vbCrLf
            TextBox1.Refresh()
            TextBox1.SelectionStart = TextBox1.TextLength
            TextBox1.ScrollToCaret()
            TabControl1.SelectedIndex = 2 ' tab 2 has the error message
            TextBox1.Focus() ' cursor to textbox1 so highlights the error
        End Try

    End Sub
    Private Sub RefreshTextBox1()
        TextBox1.Text += w3sock.Buffer
        TextBox1.Refresh()
        TextBox1.SelectionStart = TextBox1.TextLength
        TextBox1.ScrollToCaret()
    End Sub


    Private Sub HelpSIMHCompilerToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Call HelpSimhCompiler()
    End Sub
    Sub HelpSimhCompiler()
        ColorOn = False ' if color was on then turn it off
        Button1.Text = "Color On"
        If SbasicFile <> "" Then
            Call SaveSbasicFile()
        End If
        RichTextBox1.Clear()
        RichTextBox1.LoadFile("C:\N8VEM\SBSIMH.txt", RichTextBoxStreamType.PlainText)
        RichTextBox1.Focus()
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim Filename As String
        Call CompileSIMHN8VEM("Send")
        Filename = Strings.Left(SbasicFile, Len(SbasicFile) - 4)
        Call StringToPacket(Filename + vbCrLf)
    End Sub

    Private Sub CompuToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Call CompileSIMH()
    End Sub
    Sub CompileSIMH()
        ' compile using SIMH but leave the SIMH window open, and don't send to N8VEM
        Dim Location As New Process
        Dim Filename1 As String 'eg MYFILE.BAS
        Call SaveSbasicFile()
        FileOpen(1, "C:\N8VEM\AltairSIMH\SIM.BAT", OpenMode.Output) ' open a file
        PrintLine(1, "altairZ80 sim_cmd")
        FileClose(1)
        ' create the large simulation file
        FileOpen(1, "C:\N8VEM\AltairSIMH\sim_cmd", OpenMode.Output) ' open a file
        PrintLine(1, "d tracks[0-7] 254")
        PrintLine(1, "attach dsk cpm2.dsk")
        PrintLine(1, "attach dsk1 basic.dsk")
        PrintLine(1, "attach dsk2 games.dsk")
        PrintLine(1, "attach dsk3 sbasic.dsk")
        PrintLine(1, "attach dsk4 supercalc.dsk")
        PrintLine(1, "attach dsk5 tools.dsk")
        PrintLine(1, "attach dsk6 wordstar.dsk")
        PrintLine(1, "attach hdsk i.dsk")
        PrintLine(1, "set cpu 64k")
        PrintLine(1, "set cpu noitrap")
        PrintLine(1, "set cpu z80")
        PrintLine(1, "set cpu altairrom")
        PrintLine(1, "set cpu nonbanked")
        PrintLine(1, "Reset cpu ")
        PrintLine(1, "set sio ansi")
        PrintLine(1, "set sio nosleep")
        PrintLine(1, "attach sio cpm_cmd") ' attach the little file below to run a batch
        PrintLine(1, "boot dsk") ' will run till type HALT which runs HALT.COM
        PrintLine(1, "bye")
        FileClose(1)
        ' now create the file to compile
        Filename1 = Strings.Left(SbasicFile, Len(SbasicFile) - 4) 'trim the .bas
        FileCopy("C:\N8VEM\" + Filename1 + ".BAS", "C:\N8VEM\AltairSIMH\" + Filename1 + ".BAS")
        FileOpen(1, "C:\N8VEM\AltairSIMH\cpm_cmd", OpenMode.Output) ' open a file
        PrintLine(1, "D:") ' sbasic is on the D drive
        PrintLine(1, "R " + Filename1 + ".BAS") ' read the file into the SIMH
        PrintLine(1, "SBASIC " + Filename1) 'compile it
        FileClose(1)
        ' shell the altair SIMH
        Location.StartInfo.FileName = "SIM.BAT"
        Location.StartInfo.WorkingDirectory = "C:\n8vem\AltairSIMH"
        Location.Start() ' shell the batch file
        Sleep(2000)
        Kill("C:\N8VEM\AltairSIMH\" + Filename1 + ".BAS") ' clean up
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click

        Call CompileN8VEM()

    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Call CompileSIMH()
    End Sub

    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        ' take the raw cp/m file and create the new cp/m file with true/false
        Button8.ForeColor = Color.Green
        System.Windows.Forms.Application.DoEvents()
        Dim CheckBoxes(0 To 20) As String
        Dim LineOfText As String
        Dim FileLocation As String
        ' note that checked is false rather than true
        If CheckBox1.Checked = True Then CheckBoxes(1) = "FALSE" Else CheckBoxes(1) = "TRUE"
        If CheckBox2.Checked = True Then CheckBoxes(2) = "FALSE" Else CheckBoxes(2) = "TRUE"
        If CheckBox3.Checked = True Then CheckBoxes(3) = "FALSE" Else CheckBoxes(3) = "TRUE"
        If CheckBox4.Checked = True Then CheckBoxes(4) = "FALSE" Else CheckBoxes(4) = "TRUE"
        If CheckBox5.Checked = True Then CheckBoxes(5) = "FALSE" Else CheckBoxes(5) = "TRUE"
        If CheckBox6.Checked = True Then CheckBoxes(6) = "FALSE" Else CheckBoxes(6) = "TRUE"
        If CheckBox7.Checked = True Then CheckBoxes(7) = "FALSE" Else CheckBoxes(7) = "TRUE"
        If CheckBox8.Checked = True Then CheckBoxes(8) = "FALSE" Else CheckBoxes(8) = "TRUE"
        If CheckBox9.Checked = True Then CheckBoxes(9) = "FALSE" Else CheckBoxes(9) = "TRUE"
        If CheckBox10.Checked = True Then CheckBoxes(10) = "FALSE" Else CheckBoxes(10) = "TRUE"
        If CheckBox11.Checked = True Then CheckBoxes(11) = "FALSE" Else CheckBoxes(11) = "TRUE"
        If CheckBox12.Checked = True Then CheckBoxes(12) = "FALSE" Else CheckBoxes(12) = "TRUE"

        FileLocation = TextBox2.Text + "\" + TextBox6.Text
        FileOpen(2, FileLocation, OpenMode.Output) ' open a file
        FileLocation = TextBox2.Text + "\" + TextBox10.Text
        FileOpen(1, FileLocation, OpenMode.Input)
        PrintLine(2, ";**************************************************************")
        PrintLine(2, ";*")
        PrintLine(2, ";*             C P / M   VERSION   2 . 2")
        PrintLine(2, ";*")
        PrintLine(2, ";*   RECONSTRUCTED FROM MEMORY IMAGE ON FEBRUARY 27, 1981")
        PrintLine(2, ";*")
        PrintLine(2, ";*                BY CLARK A. CALKINS")
        PrintLine(2, ";*")
        PrintLine(2, ";**************************************************************")
        PrintLine(2, ";")
        PrintLine(2, ";   SET MEMORY LIMIT HERE. THIS IS THE AMOUNT OF CONTIGEOUS")
        PrintLine(2, "; RAM STARTING FROM 0000. CP/M WILL RESIDE AT THE END OF THIS SPACE.")
        PrintLine(2, "; all instructions changed to .z80 mnemonics with XIZ.COM")
        PrintLine(2, "; change dbgmonitor so it boots into cp/m directly")
        PrintLine(2, "; changed 3 files on b drive ")
        PrintLine(2, ";")
        PrintLine(2, "; add conditional assembly instructions here either .equ true or .equ false")
        PrintLine(2, "; all conditional assembly groups start with CONDxxxx:")
        PrintLine(2, "; default is true ie the original instructions eg .IF TSR is the original code")
        PrintLine(2, "; so to add a new group set the name to false else set it to true for the old code")
        PrintLine(2, "FALSE:		.EQU 0")
        PrintLine(2, "TRUE:		.EQU ~FALSE")
        PrintLine(2, "")
        PrintLine(2, "; list of conditional assembly instructions")
        PrintLine(2, "")
        PrintLine(2, "CONDSWAPAB:	.EQU	" + CheckBoxes(1) + "   ; true for original, false for new code=A=ram")
        PrintLine(2, "CONDIDESOFT:	.EQU	" + CheckBoxes(2) + "	; if no ide drive, has a significant delay on soft boot (true) or quick (false)")
        PrintLine(2, "CONDWBOOT:	.EQU	" + CheckBoxes(3) + "	; warm boot completely reloads cp/m (true) or doesn't (false)")
        PrintLine(2, "CONDTSR		.EQU	" + CheckBoxes(4) + "	; true for original, false to add TSR routines")
        PrintLine(2, "CONDSHORTMSG	.EQU	" + CheckBoxes(5) + "	; true for original warm boot signon, false for shorter one with less <CR>")
        PrintLine(2, "CONDSUPERSUB	.EQU	" + CheckBoxes(6) + "	; true for no supersub autoexec, false to run supersub autoexec")
        PrintLine(2, "CONDKEYBOARD	.EQU	" + CheckBoxes(7) + "	; true for original, false to scan PS2 keyboard in CONIN as well as serial")
        PrintLine(2, "CONDCONOUT	.EQU	" + CheckBoxes(8) + "	; true for original, false to run echooff.com TSR to maintain radio silence and LCD")
        PrintLine(2, "CONDUSRPATCH	.EQU	" + CheckBoxes(9) + "	; true for original, false to add A1> for user number as well as drive")
        PrintLine(2, "CONDMASKCONIN .EQU    " + CheckBoxes(10) + "   ; true for original, false to add a >127 mask for conin")
        PrintLine(2, "CONDABONLY    .EQU    " + CheckBoxes(11) + "   ; true for original, false to only have drive A and B")
        PrintLine(2, "CONDINVALIDDRV    .EQU    " + CheckBoxes(12) + "   ; true for original, false to go to A if an invalid drive selected")

        Do Until EOF(1)
            LineOfText = LineInput(1)
            PrintLine(2, LineOfText)
        Loop
        FileClose(1)
        FileClose(2)
        Button8.ForeColor = Color.Black
    End Sub
    Private Sub Button9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button9.Click
        ' shell the batch file
        Dim Location As New Process
        Button9.ForeColor = Color.Green
        System.Windows.Forms.Application.DoEvents()
        Location.StartInfo.FileName = TextBox8.Text
        Location.StartInfo.WorkingDirectory = TextBox2.Text
        Location.Start() ' shell the batch file
        Button9.ForeColor = Color.Black
    End Sub


    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        Call SaveRomSettings()
    End Sub
    Sub SaveRomSettings()
        Dim FileLocation As String
        Dim i As Integer
        Dim a As String
        Dim RadioButton As String
        FileLocation = TextBox2.Text + "\" + TextBox9.Text
        FileOpen(1, FileLocation, OpenMode.Output)
        ' store the files on drive B 
        a = Strings.Str(ListBox2.Items.Count)
        PrintLine(1, a) ' store the number of entries
        For i = 0 To a - 1
            PrintLine(1, ListBox2.Items(i))
        Next
        PrintLine(1, TextBox2.Text)
        PrintLine(1, TextBox4.Text)
        PrintLine(1, TextBox5.Text)
        PrintLine(1, TextBox6.Text)
        PrintLine(1, TextBox8.Text)
        PrintLine(1, TextBox10.Text)
        PrintLine(1, TextBox11.Text)
        PrintLine(1, TextBox12.Text)
        ' now store the check boxes
        PrintLine(1, CheckBox1.Checked)
        PrintLine(1, CheckBox2.Checked)
        PrintLine(1, CheckBox3.Checked)
        PrintLine(1, CheckBox4.Checked)
        PrintLine(1, CheckBox5.Checked)
        PrintLine(1, CheckBox6.Checked)
        PrintLine(1, CheckBox7.Checked)
        PrintLine(1, CheckBox8.Checked)
        PrintLine(1, CheckBox9.Checked)
        PrintLine(1, CheckBox10.Checked)
        PrintLine(1, CheckBox11.Checked)
        PrintLine(1, CheckBox12.Checked)
        If RadioButton1.Checked = True Then RadioButton = "1"
        If RadioButton2.Checked = True Then RadioButton = "2"
        If RadioButton3.Checked = True Then RadioButton = "3"
        If RadioButton4.Checked = True Then RadioButton = "4"
        If RadioButton5.Checked = True Then RadioButton = "5"
        If RadioButton6.Checked = True Then RadioButton = "6"
        PrintLine(1, RadioButton)
        FileClose(1)
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        Call LoadRomSettings()
    End Sub
    Sub LoadRomSettings()
        Dim FileLocation As String
        Dim i As Integer
        Dim a As String
        Dim RadioButton As String
        Try
            FileLocation = TextBox2.Text + "\" + TextBox9.Text
            FileOpen(1, FileLocation, OpenMode.Input)
            a = LineInput(1)
            ListBox2.Items.Clear()
            For i = 1 To Val(a)
                ListBox2.Items.Add(LineInput(1))
            Next
            TextBox2.Text = LineInput(1)
            TextBox4.Text = LineInput(1)
            TextBox5.Text = LineInput(1)
            TextBox6.Text = LineInput(1)
            TextBox8.Text = LineInput(1)
            TextBox10.Text = LineInput(1)
            TextBox11.Text = LineInput(1)
            TextBox12.Text = LineInput(1)
            ' now store the check boxes
            CheckBox1.Checked = LineInput(1)
            CheckBox2.Checked = LineInput(1)
            CheckBox3.Checked = LineInput(1)
            CheckBox4.Checked = LineInput(1)
            CheckBox5.Checked = LineInput(1)
            CheckBox6.Checked = LineInput(1)
            CheckBox7.Checked = LineInput(1)
            CheckBox8.Checked = LineInput(1)
            CheckBox9.Checked = LineInput(1)
            CheckBox10.Checked = LineInput(1)
            CheckBox11.Checked = LineInput(1)
            CheckBox12.Checked = LineInput(1)
            RadioButton = LineInput(1)
            FileClose(1)
            Select Case Val(RadioButton)
                Case 1 : RadioButton1.Checked = True
                Case 2 : RadioButton2.Checked = True
                Case 3 : RadioButton3.Checked = True
                Case 4 : RadioButton4.Checked = True
                Case 5 : RadioButton5.Checked = True
                Case 6 : RadioButton6.Checked = True
            End Select
        Catch ex As Exception
            FileClose(1)
            Call SaveRomSettings()  'if file doesn't exist then save it
        End Try
    End Sub

    Private Sub Button10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button10.Click
        ' take the raw monitor program and create new one
        Button10.ForeColor = Color.Green
        System.Windows.Forms.Application.DoEvents()
        Sleep(100)
        FileCopy("C:\n8vem\" + TextBox5.Text, "c:\n8vem\dbgmon.asm")
        Button10.ForeColor = Color.Black
    End Sub

    Private Sub Button11_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button11.Click
        Call NewSbasic()
    End Sub
    Private Sub Button12_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button12.Click
        Call OpenSbasic()
    End Sub

    Private Sub Button13_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button13.Click
        Call SaveSbasicFile()
    End Sub

    Private Sub Button16_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button16.Click
        Call HelpSbasic()
    End Sub

    Private Sub Button15_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button15.Click
        Call HelpSimhCompiler()
    End Sub

    Private Sub Button14_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button14.Click
        Call SaveAsSbasic()
    End Sub

    Private Sub Button18_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button18.Click
        ' merge testromimage.bin (1mb) and testminiromimage.bin (up to 32k)
        Dim a As Byte
        Dim b As Byte
        Dim i As Long
        Dim OneMeg As New BinaryReader(File.Open("c:\n8vem\OneMegBlank.bin", FileMode.Open))
        Dim Romimage As New BinaryReader(File.Open("c:\n8vem\Romimage.bin", FileMode.Open))
        Dim BinaryOutput As New BinaryWriter(File.Create("c:\n8vem\OneMeg.bin", FileMode.Open))
        ' peekchar gives an error and MS I think are going to abandon it anyway
        Button18.ForeColor = Color.Green
        System.Windows.Forms.Application.DoEvents()
        For i = 0 To 32767
            a = Romimage.ReadByte
            b = OneMeg.ReadByte ' discard this 
            BinaryOutput.Write(a)
        Next
        For i = 32768 To 1048575
            a = OneMeg.ReadByte
            BinaryOutput.Write(a)
        Next
        OneMeg.Close()
        BinaryOutput.Close()
        Romimage.Close()
        Try
            Kill("c:\n8vem\romimage.bin")
            Rename("c:\n8vem\onemeg.bin", "c:\n8vem\Romimage.bin")
        Catch ex As Exception
            MsgBox("Unable to delete Romimage.bin - is another process using this file?")
        End Try
        Button18.ForeColor = Color.Black
    End Sub

    Sub Fill16k()
        ' creates a 16k binary file called 16kFF.bin filled with FF
        Dim i As Long
        Dim a As Byte
        a = Strings.Val("&HFF")
        Dim BinaryOutput As New BinaryWriter(File.Create("c:\n8vem\16kFF.bin", FileMode.Open))
        For i = 0 To 16383
            BinaryOutput.Write(a)
        Next
        BinaryOutput.Close()
    End Sub

    Private Sub Button19_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button19.Click
        Dim Location As New Process
        Dim Filepath As String
        Dim Filenamepath As String
        Dim LineOfText As String
        Filepath = "c:\N8VEM"
        OpenFileDialog1.Multiselect = True
        OpenFileDialog1.InitialDirectory = Filepath
        OpenFileDialog1.FileName = "*.*" ' ? put CPM files somewhere safe
        OpenFileDialog1.ShowDialog()
        FileOpen(1, "C:\N8VEM\cpm_cmd", OpenMode.Output) ' open a file
        PrintLine(1, "F:") ' go to the F drive
        For Each Filenamepath In OpenFileDialog1.FileNames
            LineOfText = Strings.Mid(Filenamepath, 10) ' remove the file path
            LineOfText = "R " + LineOfText ' add R which runs R.COM on the simh
            PrintLine(1, LineOfText) ' read a file into the SIMH
        Next Filenamepath
        FileClose(1)
        ' create a new romimage and ramimage and run a batch file to copy files to the simh
        ' and then save the new romimage
        ' need to create three files
        ' 1) is a batch file that has a single line to run the simh
        ' 2) is the startup file for the simh (no extension) that sets all the parameters
        ' 3) is a series of commands for the simh eg a series of w filename commands to read and write files
        ' ****
        ' 1) create the batch file
        FileOpen(1, "C:\N8VEM\OneMeg.BAT", OpenMode.Output) ' open a file
        PrintLine(1, "altairZ80 n8vem") ' run n8vem (no extension)
        FileClose(1)
        ' 2) create the startup file
        FileOpen(1, "C:\N8VEM\n8vem", OpenMode.Output) ' open a file
        PrintLine(1, "set cpu z80")
        PrintLine(1, "set cpu noaltairrom")
        PrintLine(1, "set n8vem enabled")
        PrintLine(1, "set sio ansi") ' keyboard input
        PrintLine(1, "set sio port=68/0/0/0/0/f/0/t") ' otherwise the calls to the uart hang the simulation
        PrintLine(1, "set sio port=6d/00/01/0/20/f/0/f")
        '; Save ROM and RAM contents on exit
        PrintLine(1, "d n8vem saverom 1")
        PrintLine(1, "d n8vem saveram 1")
        '; image file for ROM and RAM
        PrintLine(1, "att n8vem0 romimage.bin")
        PrintLine(1, "att n8vem1 ramimage.bin")
        ' either "go" or run the cpm_cmd file below
        PrintLine(1, "set sio nosleep")
        PrintLine(1, "echo *************************************")
        PrintLine(1, "echo Type ^E to save and exit (Ctrl and E)")
        PrintLine(1, "echo *************************************")
        PrintLine(1, "attach sio cpm_cmd") ' attach the little file below to run a batch
        PrintLine(1, "go")
        PrintLine(1, "bye")
        FileClose(1)
        ' shell the altair SIMH
        Location.StartInfo.FileName = "OneMeg.BAT"
        Location.StartInfo.WorkingDirectory = "C:\n8vem\"
        Location.Start() ' shell the batch file
    End Sub

    Private Sub Button20_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button20.Click
        Dim Location As New Process
        ' see above for explanation of code. This is very similar except no command file
        FileOpen(1, "C:\N8VEM\OneMeg.BAT", OpenMode.Output) ' open a file
        PrintLine(1, "altairZ80 n8vem") ' run n8vem (no extension)
        FileClose(1)
        ' 2) create the startup file
        FileOpen(1, "C:\N8VEM\n8vem", OpenMode.Output) ' open a file
        PrintLine(1, "set cpu z80")
        PrintLine(1, "set cpu noaltairrom")
        PrintLine(1, "set n8vem enabled")
        PrintLine(1, "set sio ansi") ' keyboard input
        PrintLine(1, "set sio port=68/0/0/0/0/f/0/t") ' otherwise the calls to the uart hang the simulation
        PrintLine(1, "set sio port=6d/00/01/0/20/f/0/f")
        '; Save ROM and RAM contents on exit
        PrintLine(1, "d n8vem saverom 1")
        PrintLine(1, "d n8vem saveram 1")
        '; image file for ROM and RAM
        PrintLine(1, "att n8vem0 romimage.bin")
        PrintLine(1, "att n8vem1 ramimage.bin")
        ' either "go" or run the cpm_cmd file below
        PrintLine(1, "set sio nosleep")
        PrintLine(1, "echo *************************************")
        PrintLine(1, "echo Type ^E to save and exit (Ctrl and E)")
        PrintLine(1, "echo *************************************")
        PrintLine(1, "go")
        PrintLine(1, "bye")
        FileClose(1)
        ' shell the altair SIMH
        Location.StartInfo.FileName = "OneMeg.BAT"
        Location.StartInfo.WorkingDirectory = "C:\n8vem\"
        Location.Start() ' shell the batch file
    End Sub

    Private Sub NameMeAndRepeaterToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NameMeAndRepeaterToolStripMenuItem.Click
        Call XModemFSend("C:\N8VEM\NAMEME.COM", True)
        Call XModemFSend("C:\N8VEM\REPEATER.COM", True)
    End Sub

    Private Sub And38400COMToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles And38400COMToolStripMenuItem.Click
        Call SendBaudFiles() 'send a range of baud rate files
    End Sub


    Private Sub EchoonToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EchoonToolStripMenuItem.Click
        EchoOn = True
        Call StringToPacket("Echoon" + vbCr)
        TextBox3.Focus()
    End Sub

    Private Sub EchoOffToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EchoOffToolStripMenuItem.Click
        EchoOn = False
        Call StringToPacket("EchoOff" + vbCr)
        TextBox3.Focus()
    End Sub

    Private Sub EchoOnAnd38400ForDownloadingToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EchoOnAnd38400ForDownloadingToolStripMenuItem.Click
        Call Echo38400()
    End Sub

    Sub Echo38400()
        If SerialPortFound = True Then
            TypematicSlow = True
            SerialPort.BaudRate = 1200 ' will be this after a reboot
            Call StringToPacket("38400" + vbCr)
            Sleep(500)
            SerialPort.BaudRate = "38400" ' 38400
            Call StringToPacket("Echoon" + vbCr)
            Sleep(500)
            EchoOn = True
            TypematicSlow = False ' faster typematic speed
            'Call StringToPacket(vbCrLf) ' get the prompt
        End If
        TextBox3.Focus()
    End Sub

    Private Sub NewToolStripMenuItem_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NewToolStripMenuItem.Click
        Call SaveINI()
    End Sub
    Sub LoadINI()
        Dim LineOfText As String
        Try
            FileOpen(1, "C:\N8VEM\Settings.INI", OpenMode.Input) ' open a file
            LineOfText = LineInput(1)
            If SerialPortFound = True Then
                SerialPort.PortName = LineOfText
            End If
            LineOfText = LineInput(1)
            If SerialPortFound = True Then
                SerialPort.BaudRate = LineOfText
            End If
            FileClose(1)
        Catch ex As Exception
            FileClose(1)
            Call SaveINI() ' start a new file
            MsgBox("C:\N8VEM\Settings.INI saved, please restart the program. Also, if you got a fatal exception error when this program started, it could be because the winsock dll is not installed. You need to get the w3scokets.zip file, put the dll in c:\windows\system32, and run the registration program")
            End
        End Try
    End Sub

    Sub SaveINI()
        Dim LineOfText As String
        FileOpen(1, "C:\N8VEM\Settings.INI", OpenMode.Output) ' open a file
        LineOfText = InputBox("Serial com port eg COM1 or COM4 :", "", "COM1")
        PrintLine(1, LineOfText)
        LineOfText = InputBox("Baud rate eg 1200 9600 or 38400", "", "38400")
        PrintLine(1, LineOfText)
        FileClose(1)
    End Sub
    Private Sub MenuOnToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuOnToolStripMenuItem.Click
        TextBox3.Focus()
    End Sub

    Private Sub SlowTypematicToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SlowTypematicToolStripMenuItem.Click
        TypematicSlow = True
    End Sub

    Private Sub FastTypematicToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FastTypematicToolStripMenuItem.Click
        TypematicSlow = False
    End Sub

    Private Sub DisplayAsciiCharactersToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DisplayAsciiCharactersToolStripMenuItem.Click
        RadioAsciiCharacters = True
    End Sub

    Private Sub Button23_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button23.Click
        TypematicSlow = False ' this has been turned on and off a few times = needs proper debugging, esp on the second download
        'Call StringToPacket("=n8vem>bye" + vbCrlf) ' rerun the autoexec to get 1200
        Dim Filename As String
        TextBox3.Focus() ' focus to cp/m window
        System.Windows.Forms.Application.DoEvents() ' update the display
        SerialPort.BaudRate = 1200 ' will be this after a reboot
        Call StringToPacket("38400" + vbCr) REM not vbcrlf for some reason
        Sleep(500)
        SerialPort.BaudRate = "38400" ' 38400
        Call StringToPacket("Echoon" + vbCr)
        Sleep(500)
        EchoOn = True
        Call StringToPacket(vbCr) ' get the prompt
        Sleep(300) ' takes a while for stuff to come back on the second run
        Call CompileSIMHN8VEM("Send")
        'Sleep(2000) ' adding long delays in here
        'Call EchoOff1200()
        'Sleep(1000)
        'Call StringToPacket(vbCrLf)
        'Sleep(500)
        Filename = Strings.Left(SbasicFile, Len(SbasicFile) - 4)
        Call StringToPacket(Filename + vbCr)
    End Sub


    Private Sub Button25_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button25.Click
        OutPacket(0) = Val(TextBox15.Text)
        SerialPort.Write(OutPacket, 0, 1)
    End Sub
    Private Sub ToolStripMenuItem2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItem2.Click
        Call StringToPacket("50" + vbCrLf)
        If SerialPortFound = True Then
            SerialPort.BaudRate = "50"
        End If
        Sleep(300) ' delay to do it
        Call StringToPacket(vbCrLf)
    End Sub

    Private Sub ToolStripMenuItem3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItem3.Click
        Call StringToPacket("300" + vbCrLf)
        If SerialPortFound = True Then
            SerialPort.BaudRate = "300"
        End If
        Sleep(300) ' delay to do it
        Call StringToPacket(vbCrLf)
    End Sub

    Private Sub Button26_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button26.Click
        'http://www.dimac.net/Products/FreeProducts/w3Sockets/Reference/Refstart.htm
        Dim i As Integer
        Dim returnstring As String
        Dim sendstring As String
        Dim getchar As String
        sendstring = "dir" + vbCrLf
        w3sock.TimeOut = 5000 ' long enough to do a compile for a big program?
        w3sock.DoTelnetEmulation = True
        w3sock.TelnetEmulation = "TTY"
        w3sock.Host = "n8vem.homedns.org:3001"
        w3sock.Open()
        ' w3sock.sendline doesnt seem to work
        ' w3sock.sendtext can't send as one line, need to send with delay between each char
        'w3sock.WaitFor(">")
        For i = 1 To Len(sendstring)
            w3sock.SendText(Strings.Mid(sendstring, i, 1))
            'w3sock.SendText(Strings.Chr(i))
            'Sleep(50) ' 10 doesnt work, 50 does, 25 borderline
            Sleep(50)
        Next
        'Sleep(500)
        'w3sock.SendText(Strings.Chr(255)) ' this works, test with the lantr.com program
        'MsgBox("waiting for return line") ' finishes with a cr
        'returnstring = w3sock.GetLine()
        'w3sock.WaitFor(">") ' this works
        'returnstring = w3sock.GetText(1) ' get n characters this does not seem to work
        returnstring = w3sock.GetLine ' this does work
        i = w3sock.BytesInBuffer ' this works
        w3sock.Wait()
        'returnstring = w3sock.peek(2)
        'MsgBox(i)
        'If i > 0 Then
        'returnstring = w3sock.Buffer
        'End If
        w3sock.Close() ' close the socket
        MsgBox(returnstring)
    End Sub

    Private Sub Port0comPort1comPort2comPort3comToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Port0comPort1comPort2comPort3comToolStripMenuItem.Click
        Call XModemFSend("C:\N8VEM\PORT0.COM", True)
        Call XModemFSend("C:\N8VEM\PORT1.COM", True)
        Call XModemFSend("C:\N8VEM\PORT2.COM", True)
        Call XModemFSend("C:\N8VEM\PORT3.COM", True)
    End Sub
    Sub XModemFSend(ByRef FName As String, ByVal TimerRestart As Boolean)
        Dim Filenamepath As String
        Dim j As Integer
        Dim k As Integer
        Dim LineOfText As String
        Dim SerialString As String
        Dim Counter As Integer
        Dim ErrorString As String
        Dim Packetnumber As Integer
        Dim Checksum As Long
        Dim OnesComplement As Byte
        Dim ByteRead As Byte
        Dim BinaryFileLength As Long
        Dim BinaryFileCounter As Long
        Dim Percent As Single
        Dim ErrorCounter As Byte ' 0 to 10
        Dim CPMFilename As String
        ProgressBar1.Maximum = 100
        ProgressBar1.Minimum = 0
        ' timer restart =true for sending via menu. False for auto send
        Filenamepath = FName
        Packetnumber = 1 ' 1 for the first packet (not zero)
        Try
            Dim Input As New FileStream(Filenamepath, FileMode.Open, FileAccess.Read)
            Dim br As New BinaryReader(Input)
            Label3.Text = "Error Count"
            Label2.Text = "0%"
            BinaryFileLength = br.BaseStream.Length() - 1
            'i = Len(Filepath) + 1 + 1  ' eg c:\n8vem and a \ = 9 and 1 more for start of name only
            Call Get_CPM_Filename(Filenamepath, CPMFilename)
            CPMFilename = Strings.UCase(CPMFilename)
            LineOfText = "ERA " + CPMFilename + vbCr
            Call StringToPacket(LineOfText)
            Sleep(500) ' 1000 for 4800
            ' mod June 2009 to run new xmodemf which deletes and undone again as doesnt work
            LineOfText = "XMODEMF R " + CPMFilename + vbCr
            Call StringToPacket(LineOfText) ' 
            'LineOfText = vbCrLf
            'Call StringToPacket(LineOfText) ' send a return/LF
            Sleep(500) ' wait for text to come back before disabling timer
            ' 100 is a bit short, 300 works, 200 seems a bit better 
            ' xmodem is taking 2 seconds to acknowledge so have at least this much time
            ' to get the text back
            If TimerRestart = False Then
                Call ClearInputBuffer()  ' clear the buffer into the PC
            End If
            If TimerRestart = True Then Timer1.Enabled = False 'disable echo and all reads so can control them below
            ' if timerrestart=false then called from a program where it is already disabled
            ' now wait for the N8VEM to send a chr(21) - will still be echoing back the text for a bit
            Do
                SerialString = ""
                If SerialPortFound = True Then
                    If SerialPort.BytesToRead > 0 Then
                        SerialPort.Read(InPacket, 0, 1) ' get one byte
                        SerialString = Chr(InPacket(0)) ' get a single character/string/byte
                    End If
                End If
                If InPacket(0) = 21 Then
                    ErrorString = "NAK"
                    Exit Do ' got a ^U
                End If
                If SerialString <> "" Then
                    'LineOfText = SerialString
                    'Call TextLines(LineOfText) ' print it out unless it is a chr21
                End If
                Counter = Counter + 1
                Sleep(10) ' don't change this one - this is waiting for NAK
                Label1.Text = "Waiting for NAK to start" + Strings.Str(Counter * 10) + "ms" ' display in milliseconds
                System.Windows.Forms.Application.DoEvents() ' update the label1 message
                ' add a counter and timeout if nothing
                If Counter > 200 Then
                    ErrorString = "Timeout"
                    Exit Do
                End If
                If ErrorString <> "" Then Exit Do
            Loop
            Label1.Text = ErrorString
            ' bug with vb.net - strings don't go to 255 so have to send data as bytes
            Do
                ' act on each byte in the buffer array here
                Sleep(1) ' 60 for 4800 but 1 working for 38400
                'If Radio1200 = True Then Sleep(250)
                XOut(0) = 1 'SOH ^A
                XOut(1) = Packetnumber
                OnesComplement = 255 - Packetnumber
                XOut(2) = OnesComplement
                Packetnumber = Packetnumber + 1
                If Packetnumber > 255 Then Packetnumber = Packetnumber - 256
                Checksum = 0
                For i = 0 To 127 ' get 128 bytes from file
                    If BinaryFileCounter <= BinaryFileLength Then
                        ByteRead = br.ReadByte ' get a byte
                    Else
                        ByteRead = 26 ' pad with char 26 = hex 1A because hyperterm does this ? why but it works
                    End If
                    XOut(i + 3) = ByteRead
                    Checksum = Checksum + ByteRead
                    BinaryFileCounter = BinaryFileCounter + 1
                Next
                ' create checksum
                Do
                    If Checksum < 256 Then Exit Do ' work out checksum
                    Checksum = Checksum - 256
                Loop
                XOut(131) = Checksum
                Call OutputXout()
                System.Windows.Forms.Application.DoEvents() ' update the label
                Do
                    k = 0
                    Do
                        Sleep(10) '80 for 4800  wait for the acknowledge which is a character 6 delay of 80 only occasionally loops so k>0
                        If SerialPortFound = True Then
                            j = SerialPort.BytesToRead
                        End If
                        If j >= 1 Then
                            If SerialPortFound = True Then
                                SerialPort.Read(InPacket, 0, 1) ' get one byte
                            End If
                            Exit Do
                        End If
                        k = k + 1
                        If k > 70 Then
                            InPacket(0) = 0 ' for below error testing
                            Exit Do
                        End If
                    Loop
                    If InPacket(0) = 6 Then Exit Do ' board got the packet
                    If InPacket(0) = 21 Or InPacket(0) = 0 Then
                        ' didn't get it so try sending again
                        ErrorCounter = ErrorCounter + 1
                        Call OutputXout()
                        If InPacket(0) = 0 Then
                            Label3.Text = "Timeout waiting for Ack"
                            System.Windows.Forms.Application.DoEvents() ' update the label
                        Else
                            Label3.Text = "Nak: " + Strings.Str(ErrorCounter)
                            System.Windows.Forms.Application.DoEvents() ' update the label
                        End If
                    End If
                    If ErrorCounter >= 3 Then Exit Do ' snandard xmodem is 10 but make this 3
                Loop
                If ErrorCounter >= 10 Then
                    Label1.Text = "10 errors - aborting"
                    Label2.Text = "0%"
                    OutPacket(0) = 24 ' send a ^X cancel
                    If SerialPortFound = True Then
                        SerialPort.Write(OutPacket, 0, 1) ' send 1 byte
                        OutPacket(0) = 3 ' send a ^C
                        SerialPort.Write(OutPacket, 0, 1) ' send 1 byte
                    End If
                    Exit Do
                End If
                If BinaryFileCounter > BinaryFileLength Then Exit Do ' finish up
                Label1.Text = "Sent packet: " + Strings.Str(Packetnumber) + " = OK"
                Percent = BinaryFileCounter / BinaryFileLength
                Percent = Percent * 100
                Percent = Int(Percent)
                Label2.Text = Strings.Str(Percent) + "%"
                ProgressBar1.Value = Percent
            Loop
            If ErrorCounter < 3 Then
                Sleep(100)
                OutPacket(0) = 4
                If SerialPortFound = True Then
                    SerialPort.Write(OutPacket, 0, 1) ' send 1 byte
                End If
                Label2.Text = "100%"
                Label1.Text = "Finished"
                ProgressBar1.Value = 0 'done
            End If
            Input.Close()
            Sleep(200) ' wait for next file
            If TimerRestart = True Then Timer1.Enabled = True ' update the text - no sleeps after this
            System.Windows.Forms.Application.DoEvents() ' update the labels
        Catch ex As Exception
            Close()
            Label1.Text = Filenamepath + " not found"
            If TimerRestart = TimerRestart = True Then Timer1.Enabled = True ' update the text
            System.Windows.Forms.Application.DoEvents() ' update the labels
            Sleep(1000) ' so time to read message
        End Try
    End Sub
    Private Sub Button28_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button28.Click
        'RichTextBox4.AcceptsTab = True at startup so tabs stay in the text box
        AssemblyFile = "ASSEMBLY.ASM"
        AssemblyFile = InputBox("Filename eg MYFILE.ASM (no more than 8 characters):", , AssemblyFile)
        AssemblyFile = Strings.UCase(AssemblyFile)
        Label41.Text = AssemblyFile
        RichTextBox4.Text = ""
        'RichTextBox4.AppendText(vbTab + ".TITLE	Assembly for the N8VEM using Bill Beech's RASM compiler" + vbCrLf)
        RichTextBox4.AppendText(vbTab + ".Z80" + vbCrLf)
        RichTextBox4.AppendText(vbTab + "org 100H" + vbCrLf)
        RichTextBox4.AppendText("main:" + vbTab + "ld a,1" + vbCrLf)
        RichTextBox4.AppendText(vbTab + "ret" + vbCrLf)
        RichTextBox4.AppendText(vbTab + "end" + vbCrLf)
        RichTextBox4.Focus()
    End Sub

    Private Sub Button32_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button32.Click
        ' compile with Bill Beech's RASM assembler, download and run
        Dim Location As New Process
        Dim filename1 As String
        Dim filename2 As String
        Dim filename_noextension As String
        Dim batchcommand As String
        Dim LineOfText As String
        Call SaveAssemblyFile()
        filename1 = AssemblyFile
        filename_noextension = Strings.Left(filename1, Len(filename1) - 4)
        If Len(filename_noextension) > 8 Then
            MsgBox("Warning - filename is >8 characters long and won't work with CP/M. Suggest renaming file")
        End If
        filename2 = filename_noextension + ".COM"
        batchcommand = "rasm -b -l " + filename_noextension
        FileOpen(1, "C:\N8vem\ASM.BAT", OpenMode.Output)
        PrintLine(1, batchcommand)
        FileClose(1)
        Location.StartInfo.FileName = "ASM.BAT"
        Location.StartInfo.WorkingDirectory = "C:\n8vem"
        Location.Start() ' shell the batch file
        Do
            ' wait till batch file finishes
        Loop Until Location.HasExited = True
        Try
            Kill("C:\N8VEM\" + filename_noextension + ".COM")
        Catch ex As Exception
            ' file didn't exist
        End Try
        ' test .lst file to see if any errors. If ok last line will be "No error(s) found"
        FileOpen(1, "C:\N8vem\" + filename_noextension + ".LST", OpenMode.Input)
        Do Until EOF(1)
            LineOfText = LineInput(1) ' leaves last line with the error message or not
        Loop
        FileClose(1)
        If LineOfText = "No error(s) found" Then
            ' rename the file
            TabControl1.SelectedIndex = 0 ' display cp/m
            TextBox3.Focus() 'display to cp/m
            Rename("C:\N8VEM\" + filename_noextension + ".BIN", "C:\N8VEM\" + filename_noextension + ".COM") ' bills program makes.bin files
            Call StringToPacket(vbCrLf) ' clear any rubbish that might be on the terminal
            Sleep(100)
            Call StringToPacket(vbCrLf) ' clear any rubbish that might be on the terminal
            Sleep(100)
            Call XModemFSend("C:\N8VEM\" + filename2, True)
            Call StringToPacket(filename_noextension + vbLf) ' don't use crlf as the extra cr character upsets the first read console call in routines.asm
        Else
            ' error found so recompile and leave the batch file window open
            FileOpen(1, "C:\N8vem\ERROR.BAT", OpenMode.Output)
            PrintLine(1, batchcommand)
            PrintLine(1, "Pause") ' leaves the batch file running
            FileClose(1)
            Location.StartInfo.FileName = "ERROR.BAT"
            Location.StartInfo.WorkingDirectory = "C:\n8vem"
            Location.Start() ' shell the batch file
        End If
    End Sub

    Private Sub Button31_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button31.Click
        Call SaveAssemblyFile()
    End Sub
    Sub SaveAssemblyFile()
        If AssemblyFile = "" Then
            AssemblyFile = InputBox("Filename eg MYFILE.ASM: ", , AssemblyFile)
            Label41.Text = AssemblyFile
        End If
        RichTextBox4.SaveFile("C:\N8VEM\" + AssemblyFile, RichTextBoxStreamType.PlainText)
        RichTextBox4.Focus()
    End Sub
    Private Sub Button33_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button33.Click
        Dim Filenamepath As String
        Dim Filepath As String
        Filepath = "c:\N8VEM"
        SaveFileDialog1.InitialDirectory = Filepath
        SaveFileDialog1.FileName = AssemblyFile
        SaveFileDialog1.ShowDialog()
        Filenamepath = SaveFileDialog1.FileName
        Try
            RichTextBox4.SaveFile(Filenamepath, RichTextBoxStreamType.PlainText)
            AssemblyFile = Strings.Mid(Filenamepath, 10)
            Label41.Text = AssemblyFile
            RichTextBox4.Focus()
        Catch ex As Exception
            're user probably hit cancel
        End Try
    End Sub

    Private Sub Button30_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button30.Click
        Dim Filepath As String
        Filepath = "c:\N8VEM"
        OpenFileDialog1.Multiselect = False
        OpenFileDialog1.InitialDirectory = Filepath
        OpenFileDialog1.FileName = "*.ASM"
        OpenFileDialog1.ShowDialog()
        AssemblyFile = OpenFileDialog1.FileName
        AssemblyFile = Strings.Mid(AssemblyFile, 10) ' strip off directory
        AssemblyFile = Strings.UCase(AssemblyFile)
        Label41.Text = AssemblyFile
        Try
            RichTextBox4.LoadFile("C:\N8VEM\" + AssemblyFile, RichTextBoxStreamType.PlainText)
            'TabControl1.SelectedIndex = 1
            RichTextBox4.Focus()
        Catch ex As Exception
            ' user probably hit cancel
        End Try
    End Sub

    Private Sub Button27_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button27.Click
        Dim Location As New Process
        Location.StartInfo.FileName = Strings.Left(Label41.Text, Len(Label41.Text) - 4) + ".LST"
        Location.StartInfo.WorkingDirectory = "C:\n8vem"
        Location.Start()
    End Sub
    Private Sub DDTAndDDTZToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DDTAndDDTZToolStripMenuItem.Click
        Call XModemFSend("C:\N8VEM\DDT.COM", True)
        Call XModemFSend("C:\N8VEM\DDTZ.COM", True)
    End Sub


    Private Sub Udrive_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Udrive.Click
        Call XModemFSend("C:\N8VEM\USTART.COM", True)
        Call XModemFSend("C:\N8VEM\UREAD.COM", True)
        Call XModemFSend("C:\N8VEM\UWRITE.COM", True)
        Call XModemFSend("C:\N8VEM\UERASE.COM", True)
        Call XModemFSend("C:\N8VEM\UDIR.COM", True)
        Call XModemFSend("C:\N8VEM\AUTOU.SUB", True)
        Call StringToPacket("ERA AUTOEXEC.SUB" + vbCrLf)
        Sleep(300) ' delay to do it
        Call StringToPacket("REN AUTOEXEC.SUB=AUTOU.SUB" + vbCrLf)
        Call StringToPacket("SUPERSUB AUTOEXEC" + vbCrLf)
    End Sub

    Private Sub RadioLinkToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioLinkToolStripMenuItem.Click
        Call XModemFSend("C:\N8VEM\ECHOOFF.COM", True)
        Call XModemFSend("C:\N8VEM\ECHOON.COM", True)
        Call XModemFSend("C:\N8VEM\KEYOFF.COM", True)
        Call XModemFSend("C:\N8VEM\AUTORAD.SUB", True)
        Call StringToPacket("ERA AUTOEXEC.SUB" + vbCrLf)
        Sleep(300) ' delay to do it
        Call StringToPacket("REN AUTOEXEC.SUB=AUTORAD.SUB" + vbCrLf)
        Call StringToPacket("SUPERSUB AUTOEXEC" + vbCrLf)
    End Sub

    Private Sub MbasicToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Call XModemFSend("C:\N8VEM\UMBASIC.SUB", True)
        Call StringToPacket("SUPERSUB UMBASIC" + vbCrLf)
    End Sub
    Private Sub AutoexecToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AutoexecToolStripMenuItem1.Click
        Dim Filename As String
        Filename = InputBox("Name of file in autoexec eg MESH919.COM", , "MESH919.COM")
        Filename = UCase(Filename)
        If Strings.Right(Filename, 4) = ".COM" Then Filename = Strings.Left(Filename, Len(Filename) - 4)
        FileOpen(1, "C:\N8VEM\MESH.SUB", OpenMode.Output) ' open a file
        PrintLine(1, Filename)
        FileClose(1)
        Call XModemFSend("C:\N8VEM\MESH.SUB", True)
        Call StringToPacket("ERA AUTOEXEC.SUB" + vbCrLf)
        Sleep(300) ' delay to do it
        Call StringToPacket("PIP AUTOEXEC.SUB=MESH.SUB" + vbCrLf)
        Sleep(500) ' delay to do it
    End Sub

    Private Sub NamemeAndRoutcommToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NamemeAndRoutcommToolStripMenuItem.Click
        Dim Filename As String
        Filename = InputBox("Name eg MESH919.COM", , "MESH919.COM")
        Call XModemFSend("C:\N8VEM\" + Filename, True)
    End Sub
  
    Sub NumberToHex(ByRef N As Integer, ByRef Hexstring As String)
        ' 0 to 255 and returns $00 to $FF
        Hexstring = Strings.Hex(N)
        Hexstring = Trim(Hexstring)
        If N < 16 Then Hexstring = "0" + Hexstring
        Hexstring = "$" + Hexstring
    End Sub


    'Private Sub Button34_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button34.Click
    ' ' create the batch file Makerom.bat
    ' Dim LineOfText As String
    ' Dim FileBin As String
    ' Dim FileLocation As String
    ' Dim Complete As String
    ' Dim Complete2 As String
    ' Dim i As Integer
    '     Button34.ForeColor = Color.Green
    '     System.Windows.Forms.Application.DoEvents()
    '     Sleep(200)
    '     Call Fill16k() ' creates 32k.bin filled with E5
    '     FileLocation = TextBox2.Text + "\" + TextBox8.Text
    '     FileOpen(1, FileLocation, OpenMode.Output)
    '    For i = 0 To ListBox2.Items.Count - 1
    '        Complete = Complete + ListBox2.Items(i) + "+"
    '    Next
    '    Complete = Complete + "16kFF.bin"
    'Complete = Strings.Left(Complete, Len(Complete) - 1) ' remove the last +
    '    FileBin = Strings.Left(TextBox4.Text, Len(TextBox4.Text) - 4) + ".bin"
    '    PrintLine(1, "tasm -t80 -b " + TextBox4.Text + " " + FileBin)
    '    Complete2 = "copy /B " + FileBin
    '    FileBin = Strings.Left(TextBox12.Text, Len(TextBox12.Text) - 4) + ".bin"
    '    PrintLine(1, "tasm -t80 -b " + TextBox12.Text + " " + FileBin)
    '    Complete2 = Complete2 + "+" + FileBin
    '    FileBin = Strings.Left(TextBox6.Text, Len(TextBox6.Text) - 4) + ".bin"
    '    PrintLine(1, "tasm -t80 -b " + TextBox6.Text + " " + FileBin)
    '    Complete2 = Complete2 + "+" + FileBin
    '    FileBin = Strings.Left(TextBox17.Text, Len(TextBox17.Text) - 4) + ".bin"
    '    PrintLine(1, "tasm -t80 -b -fE5 " + TextBox17.Text + " " + FileBin)
    '    Complete2 = Complete2 + "+" + FileBin
    '    Complete = Complete2 + "+" + Complete + " " + TextBox11.Text
    '    PrintLine(1, Complete)
    '   PrintLine(1, "pause")
    '    FileClose(1)
    '    Button34.ForeColor = Color.Black
    'End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Dim a As Integer
        a = ListBox2.SelectedIndex
        If a = -1 Then
            MsgBox("No item selected")
        Else
            ListBox2.Items.RemoveAt(a)
        End If
    End Sub

    Private Sub Button29_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button29.Click
        Dim LineOfText As String
        Dim Filenamepath As String
        Dim Filepath As String
        Filepath = "c:\N8VEM"
        OpenFileDialog1.Multiselect = True
        OpenFileDialog1.InitialDirectory = Filepath
        OpenFileDialog1.FileName = "*.*" ' ? put CPM files somewhere safe
        OpenFileDialog1.ShowDialog()
        For Each Filenamepath In OpenFileDialog1.FileNames
            LineOfText = Strings.Mid(Filenamepath, 10) ' remove the full directory listing
            LineOfText = Strings.UCase(LineOfText)
            Call ListBox2.Items.Add(LineOfText)
        Next Filenamepath
    End Sub

    Private Sub Button35_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button35.Click
        Dim DiskImage(0 To &H7FFF) As Byte
        Dim LineOfText As String
        Dim Filenamepath As String
        Dim BinaryFileLength As Long
        Dim Records As Integer ' 128 bytes
        Dim rc As Long
        Dim i As Integer
        Dim ListboxCounter
        Dim Blocks As Integer ' 1024 bytes
        Dim bc As Long
        Dim DiskPointer As Long
        Dim ByteRead As Byte
        Dim FilePointer As Long
        Dim DiskMapCounter As Long
        Dim FileNameBuild As String
        Dim FCB(0 To 31) As Byte
        Dim DirectoryPointer As Long
        Dim ProgressString As String
        Dim RemainingBytes As Long
        RichTextBox5.Clear()
        Button35.ForeColor = Color.Green
        System.Windows.Forms.Application.DoEvents()
        Sleep(200)
        DiskPointer = &H2C00
        FilePointer = &H2C00
        RemainingBytes = &H8000 - &H2C00
        For i = &H0 To &H7FFF ' Do this in hex
            DiskImage(i) = &HE5 ' clear the disk
        Next
        ' files start at 2C00 and go to 7FFF which is 11264 up
        For ListboxCounter = 0 To ListBox2.Items.Count - 1
            LineOfText = ListBox2.Items(ListboxCounter)
            Filenamepath = "C:\N8VEM\" + LineOfText
            Dim BinaryInput As New FileStream(Filenamepath, FileMode.Open, FileAccess.Read)
            Dim br As New BinaryReader(BinaryInput)
            BinaryFileLength = br.BaseStream.Length() - 1
            rc = 0 ' there is a way to do with with integer division but it is complicated
            Records = 0 ' and involves adding 0.5 to the integer afterwards and MOD
            Do Until rc > BinaryFileLength
                Records = Records + 1
                rc = rc + 128
            Loop
            bc = 0
            Blocks = 0
            Do Until bc > BinaryFileLength
                Blocks = Blocks + 1
                bc = bc + 1024
            Loop
            For i = 0 To BinaryFileLength
                ByteRead = br.ReadByte ' get a byte
                DiskImage(DiskPointer) = ByteRead
                DiskPointer = DiskPointer + 1
            Next
            BinaryInput.Close() ' close the binary file
            FilePointer = FilePointer + Blocks * 1024 ' get location for next file
            DiskPointer = FilePointer ' ready for next file
            ProgressString = LineOfText + " " + Strings.Str(Blocks) + "k" + vbCrLf
            RichTextBox5.AppendText(ProgressString)
            RemainingBytes = RemainingBytes - Blocks * 1024
            ProgressString = "Free: " + Strings.Str(RemainingBytes) + vbCrLf
            RichTextBox5.AppendText(ProgressString)
        Next
        ' now create the directory listing starts at &h2800
        DiskMapCounter = 1 ' start at 1 and add for each file
        DirectoryPointer = &H2800 ' start here
        For ListboxCounter = 0 To ListBox2.Items.Count - 1
            LineOfText = ListBox2.Items(ListboxCounter)
            Filenamepath = "C:\N8VEM\" + LineOfText
            Dim Input As New FileStream(Filenamepath, FileMode.Open, FileAccess.Read)
            Dim br As New BinaryReader(Input)
            BinaryFileLength = br.BaseStream.Length() - 1 ' 2279 for xmodem
            Input.Close() ' close the binary file
            rc = 0 ' there is a way to do with with integer division but it is complicated
            Records = 0 ' and involves adding 0.5 to the integer afterwards and MOD
            Do Until rc > BinaryFileLength
                Records = Records + 1
                rc = rc + 128
            Loop
            bc = 0
            Blocks = 0
            Do Until bc > BinaryFileLength
                Blocks = Blocks + 1
                bc = bc + 1024
            Loop
            For i = 0 To 31
                FCB(i) = 0 ' clear the fcb as most bytes are zero
            Next
            i = Strings.InStr(LineOfText, ".")
            FileNameBuild = Strings.Left(LineOfText, i - 1) + "        " ' add spaces
            FileNameBuild = Strings.Left(FileNameBuild, 8) 'truncate to 8
            FileNameBuild += Strings.Mid(LineOfText, i + 1, 3) ' add the extension
            For i = 1 To Len(FileNameBuild)
                FCB(i) = Strings.Asc(Strings.Mid(FileNameBuild, i, 1))
            Next
            FCB(15) = Records
            ' list of 1k blocks
            For i = 1 To Blocks ' fill up the array
                FCB(i + 15) = DiskMapCounter ' start at 16
                DiskMapCounter = DiskMapCounter + 1
            Next
            For i = 0 To 31
                DiskImage(DirectoryPointer) = FCB(i)
                DirectoryPointer = DirectoryPointer + 1 ' add one
            Next
        Next
        ' now save this to a binary file
        Filenamepath = "C:\N8VEM\BDRIVE.BIN"
        Dim BinaryOutput As New FileStream(Filenamepath, FileMode.Create, FileAccess.Write)
        BinaryOutput.Write(DiskImage, &H2800, &H7FFF - &H2800)
        BinaryOutput.Close()
        Button35.ForeColor = Color.Black
    End Sub

    Private Sub Button36_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button36.Click
        ' create the batch file Makerom.bat
        Dim LineOfText As String
        Dim FileBin As String
        Dim FileLocation As String
        Dim Complete As String
        Dim Complete2 As String
        Dim i As Integer
        Button36.ForeColor = Color.Green
        System.Windows.Forms.Application.DoEvents()
        Sleep(200)
        FileLocation = TextBox2.Text + "\" + TextBox8.Text
        FileOpen(1, FileLocation, OpenMode.Output)
        FileBin = Strings.Left(TextBox4.Text, Len(TextBox4.Text) - 4) + ".bin"
        PrintLine(1, "tasm -t80 -b " + TextBox4.Text + " " + FileBin)
        Complete2 = "copy /B " + FileBin
        FileBin = Strings.Left(TextBox12.Text, Len(TextBox12.Text) - 4) + ".bin"
        PrintLine(1, "tasm -t80 -b " + TextBox12.Text + " " + FileBin)
        Complete2 = Complete2 + "+" + FileBin
        FileBin = Strings.Left(TextBox6.Text, Len(TextBox6.Text) - 4) + ".bin"
        PrintLine(1, "tasm -t80 -b " + TextBox6.Text + " " + FileBin)
        Complete2 = Complete2 + "+" + FileBin
        Complete = Complete2 + "+" + "BDRIVE.BIN" + " " + TextBox11.Text
        PrintLine(1, Complete)
        PrintLine(1, "pause")
        FileClose(1)
        Button36.ForeColor = Color.Black
    End Sub

    Private Sub RadioButton1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton1.CheckedChanged
        TextBox5.Text = "dbgmon96.asm"
    End Sub

    Private Sub RadioButton2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton2.CheckedChanged
        TextBox5.Text = "dbgmon38.asm"
    End Sub

    Private Sub RadioButton3_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton3.CheckedChanged
        TextBox5.Text = "dbgmon_autocpm_1200.asm"
    End Sub

    Private Sub RadioButton4_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton4.CheckedChanged
        TextBox5.Text = "dbgmon_autocpm_9600.asm"
    End Sub

    Private Sub RadioButton5_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton5.CheckedChanged
        TextBox5.Text = "dbgmon_autocpm_38400.asm"
    End Sub

    Private Sub RadioButton6_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton6.CheckedChanged
        TextBox5.Text = "dbgmon_autocpm_38400_key_lcd.asm"
    End Sub

    Private Sub FormatToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FormatToolStripMenuItem1.Click
        Call FormatU()
        Call XModemFSend("C:\N8VEM\UALL.SUB", True)
        Call StringToPacket("A:" + vbCr)
        Sleep(500) ' delay to do it
        Call StringToPacket("SUPERSUB UALL" + vbCr)
    End Sub
    Sub FormatU()
        ' **** AFTER A LOT OF RESEARCH, something does not work with copying files over
        ' tried this many combinations and best to still xmodem over the first ones
        ' a little slower though
        ' for some reason it does work manually though
        Call StringToPacket(vbCr) ' hit enter to finish any half entered lines
        Sleep(500)
        Call StringToPacket(vbCr) ' hit enter to finish any half entered lines
        Sleep(500)
        Call StringToPacket("B:" + vbCr)
        Sleep(500) ' wait to do it
        Call StringToPacket("FORMAT" + vbCr)
        Sleep(5000) ' takes about 1 sec at 8Mhz so 5 secs should be plenty
        Call StringToPacket("B:" + vbCrLf)
        Sleep(300) ' delay to do it
        Call XModemSend("C:\N8VEM\PIP.COM", True)
        Call StringToPacket("A:" + vbCrLf)
        Sleep(300) ' delay to do it
        Call StringToPacket("PIP A:XMODEM.COM=B:XMODEM.COM" + vbCrLf)
        Sleep(2000) ' delay to do it
        'Call SendBaudFiles() '1200 9600 and 38400
        'Call StringToPacket("38400" + vbCrLf)
        'SerialPort.BaudRate = "38400" ' 38400
        Call XModemSend("C:\N8VEM\XMODEMF.COM", True) ' fast version of xmodem (too fast for manual downloads)
        Call XModemFSend("C:\N8VEM\USTART.COM", True)
        Call XModemFSend("C:\N8VEM\UREAD.COM", True)
        Call XModemFSend("C:\N8VEM\SUPERSUB.COM", True)
        Call StringToPacket("USTART" + vbCr)
        Sleep(3000)
    End Sub
    Private Sub FormatAndEssentialsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FormatAndEssentialsToolStripMenuItem.Click
        Call FormatU()
        Call XModemFSend("C:\N8VEM\UTINY.SUB", True)
        Call StringToPacket("A:" + vbCr)
        Sleep(500) ' delay to do it
        Call StringToPacket("SUPERSUB UTINY" + vbCr)
    End Sub

    Private Sub PropellerXmodemToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PropellerXmodemToolStripMenuItem.Click
        Dim Filenamepath As String
        Dim Filepath As String
        Filepath = "c:\N8VEM"
        OpenFileDialog1.Multiselect = True
        OpenFileDialog1.InitialDirectory = Filepath
        OpenFileDialog1.FileName = "*.*" ' ? put CPM files somewhere safe
        OpenFileDialog1.ShowDialog()
        For Each Filenamepath In OpenFileDialog1.FileNames
            Call XModemPSend(Filenamepath, True)
        Next Filenamepath
    End Sub
    Sub XModemPSend(ByRef FName As String, ByVal TimerRestart As Boolean)
        Dim Filenamepath As String
        Dim j As Integer
        Dim k As Integer
        Dim LineOfText As String
        Dim SerialString As String
        Dim Counter As Integer
        Dim ErrorString As String
        Dim Packetnumber As Integer
        Dim Checksum As Long
        Dim OnesComplement As Byte
        Dim ByteRead As Byte
        Dim BinaryFileLength As Long
        Dim BinaryFileCounter As Long
        Dim Percent As Single
        Dim ErrorCounter As Byte ' 0 to 10
        Dim CPMFilename As String
        ProgressBar1.Maximum = 100
        ProgressBar1.Minimum = 0
        ' timer restart =true for sending via menu. False for auto send
        Filenamepath = FName
        Packetnumber = 1 ' 1 for the first packet (not zero)
        Try
            Dim Input As New FileStream(Filenamepath, FileMode.Open, FileAccess.Read)
            Dim br As New BinaryReader(Input)
            Label3.Text = "Error Count"
            Label2.Text = "0%"
            BinaryFileLength = br.BaseStream.Length() - 1
            'i = Len(Filepath) + 1 + 1  ' eg c:\n8vem and a \ = 9 and 1 more for start of name only
            Call Get_CPM_Filename(Filenamepath, CPMFilename)
            CPMFilename = Strings.UCase(CPMFilename)
            ' send a <CR>  (in case some rubbish characters on the screen)
            ' LineOfText = Strings.Chr(13)
            ' Call StringToPacket(LineOfText)
            ' Sleep(300) ' 300 for 4800 to process the return
            ' erase the file in case it exists
            ' Call StringToPacket(vbCrLf) ' in case need to kick start it even more
            ' Sleep(300)
            LineOfText = "ERA " + CPMFilename + vbCr
            Call StringToPacket(LineOfText)
            'LineOfText = vbCrLf
            'Call StringToPacket(LineOfText)
            Sleep(5000) ' 1000 for 4800 ' 300
            ' run xmodem on the board
            LineOfText = "XMODEMP R " + CPMFilename + vbCr
            Call StringToPacket(LineOfText) ' 
            'LineOfText = vbCrLf
            'Call StringToPacket(LineOfText) ' send a return/LF
            Sleep(500) ' wait for text to come back before disabling timer
            ' 100 is a bit short, 300 works, 200 seems a bit better 
            ' xmodem is taking 2 seconds to acknowledge so have at least this much time
            ' to get the text back
            If TimerRestart = False Then
                Call ClearInputBuffer()  ' clear the buffer into the PC
            End If
            If TimerRestart = True Then Timer1.Enabled = False 'disable echo and all reads so can control them below
            ' if timerrestart=false then called from a program where it is already disabled
            ' now wait for the N8VEM to send a chr(21) - will still be echoing back the text for a bit
            Do
                SerialString = ""
                If SerialPortFound = True Then
                    If SerialPort.BytesToRead > 0 Then
                        SerialPort.Read(InPacket, 0, 1) ' get one byte
                        SerialString = Chr(InPacket(0)) ' get a single character/string/byte
                    End If
                End If
                If InPacket(0) = 21 Then
                    ErrorString = "NAK"
                    Exit Do ' got a ^U
                End If
                If SerialString <> "" Then
                    'LineOfText = SerialString
                    'Call TextLines(LineOfText) ' print it out unless it is a chr21
                End If
                Counter = Counter + 1
                Sleep(10) ' don't change this one - this is waiting for NAK *** was 10
                Label1.Text = "Waiting for NAK to start" + Strings.Str(Counter * 10) + "ms" ' display in milliseconds
                System.Windows.Forms.Application.DoEvents() ' update the label1 message
                ' add a counter and timeout if nothing
                If Counter > 5000 Then ' 800
                    ErrorString = "Timeout"
                    Exit Do
                End If
                If ErrorString <> "" Then Exit Do
            Loop
            Label1.Text = ErrorString
            ' bug with vb.net - strings don't go to 255 so have to send data as bytes
            Do
                ' act on each byte in the buffer array here
                Sleep(1) ' 60 for 4800 but 1 working for 38400
                'If Radio1200 = True Then Sleep(250)
                XOut(0) = 1 'SOH ^A
                XOut(1) = Packetnumber
                OnesComplement = 255 - Packetnumber
                XOut(2) = OnesComplement
                Packetnumber = Packetnumber + 1
                If Packetnumber > 255 Then Packetnumber = Packetnumber - 256
                Checksum = 0
                For i = 0 To 127 ' get 128 bytes from file
                    If BinaryFileCounter <= BinaryFileLength Then
                        ByteRead = br.ReadByte ' get a byte
                    Else
                        ByteRead = 26 ' pad with char 26 = hex 1A because hyperterm does this ? why but it works
                    End If
                    XOut(i + 3) = ByteRead
                    Checksum = Checksum + ByteRead
                    BinaryFileCounter = BinaryFileCounter + 1
                Next
                ' create checksum
                Do
                    If Checksum < 256 Then Exit Do ' work out checksum
                    Checksum = Checksum - 256
                Loop
                XOut(131) = Checksum
                Call OutputXout()
                System.Windows.Forms.Application.DoEvents() ' update the label
                Do
                    k = 0
                    Do
                        Sleep(10) '80 for 4800  wait for the acknowledge which is a character 6 delay of 80 only occasionally loops so k>0
                        If SerialPortFound = True Then
                            j = SerialPort.BytesToRead
                        End If
                        If j >= 1 Then
                            If SerialPortFound = True Then
                                SerialPort.Read(InPacket, 0, 1) ' get one byte
                            End If
                            Exit Do
                        End If
                        k = k + 1
                        If k > 5000 Then ' 70?
                            InPacket(0) = 0 ' for below error testing
                            Exit Do
                        End If
                    Loop
                    If InPacket(0) = 6 Then Exit Do ' board got the packet
                    If InPacket(0) = 21 Or InPacket(0) = 0 Then
                        ' didn't get it so try sending again
                        ErrorCounter = ErrorCounter + 1
                        Call OutputXout()
                        Label3.Text = "Error: " + Strings.Str(ErrorCounter)
                        System.Windows.Forms.Application.DoEvents() ' update the label
                    End If
                    Label3.Text = "Error: " + Strings.Str(ErrorCounter)
                    System.Windows.Forms.Application.DoEvents() ' update the label
                    If ErrorCounter >= 10 Then Exit Do
                Loop
                If ErrorCounter >= 10 Then
                    Label1.Text = "10 errors - aborting"
                    Label2.Text = "0%"
                    OutPacket(0) = 24 ' send a ^X cancel
                    If SerialPortFound = True Then
                        SerialPort.Write(OutPacket, 0, 1) ' send 1 byte
                        OutPacket(0) = 3 ' send a ^C
                        SerialPort.Write(OutPacket, 0, 1) ' send 1 byte
                    End If
                    Exit Do
                End If
                If BinaryFileCounter > BinaryFileLength Then Exit Do ' finish up
                Label1.Text = "Sent packet: " + Strings.Str(Packetnumber) + " = OK"
                Percent = BinaryFileCounter / BinaryFileLength
                Percent = Percent * 100
                Percent = Int(Percent)
                Label2.Text = Strings.Str(Percent) + "%"
                ProgressBar1.Value = Percent
            Loop
            If ErrorCounter < 10 Then
                Sleep(100)
                OutPacket(0) = 4
                If SerialPortFound = True Then
                    SerialPort.Write(OutPacket, 0, 1) ' send 1 byte
                End If
                Label2.Text = "100%"
                Label1.Text = "Finished all OK"
                ProgressBar1.Value = 0 'done
            End If
            Input.Close()
            Sleep(200) ' wait for next file
            If TimerRestart = True Then Timer1.Enabled = True ' update the text - no sleeps after this
            System.Windows.Forms.Application.DoEvents() ' update the labels
        Catch ex As Exception
            Close()
            Label1.Text = Filenamepath + " not found"
            If TimerRestart = TimerRestart = True Then Timer1.Enabled = True ' update the text
            System.Windows.Forms.Application.DoEvents() ' update the labels
            Sleep(1000) ' so time to read message
        End Try
    End Sub

    Private Sub Button34_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button34.Click
        BDSCfile = "NEW.C"
        BDSCfile = InputBox("Filename eg MYFILE.C (no more than 8 characters):", , BDSCfile)
        BDSCfile = Strings.UCase(BDSCfile)
        Label12.Text = BDSCfile
        RichTextBox6.Text = ""
        RichTextBox6.AppendText("/*" + vbCrLf)
        RichTextBox6.AppendText("Hello world example in BDS C" + vbCrLf)
        RichTextBox6.AppendText("*/" + vbCrLf)
        RichTextBox6.AppendText("#include <stdio.h>" + vbCrLf)
        RichTextBox6.AppendText("main()" + vbCrLf)
        RichTextBox6.AppendText("{" + vbCrLf)
        RichTextBox6.AppendText("     printf(" + Chr(34) + "Hello World\n" + Chr(34) + ");" + vbCrLf)
        RichTextBox6.AppendText("}" + vbCrLf)
        TabControl1.SelectedIndex = 7
        RichTextBox6.Focus()
    End Sub

    Private Sub Button37_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button37.Click
        Dim Filepath As String
        Filepath = "c:\N8VEM"
        OpenFileDialog1.Multiselect = False
        OpenFileDialog1.InitialDirectory = Filepath
        OpenFileDialog1.FileName = "*.C"
        OpenFileDialog1.ShowDialog()
        BDSCfile = OpenFileDialog1.FileName
        BDSCfile = Strings.Mid(BDSCfile, 10) ' strip off directory
        BDSCfile = Strings.UCase(BDSCfile)
        Label12.Text = BDSCfile
        Try
            RichTextBox6.LoadFile("C:\N8VEM\" + BDSCfile, RichTextBoxStreamType.PlainText)
            TabControl1.SelectedIndex = 7 ' tab number 0-7 (8)
            RichTextBox6.Focus()
        Catch ex As Exception
            ' user probably hit cancel
        End Try
    End Sub

    Private Sub Button38_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button38.Click
        Call SaveBDSC()
    End Sub
    Sub SaveBDSC()
        If BDSCfile = "" Then
            BDSCfile = InputBox("Filename eg MYFILE.C: ", , BDSCfile)
            Label12.Text = BDSCfile
        End If
        RichTextBox6.SaveFile("C:\N8VEM\" + BDSCfile, RichTextBoxStreamType.PlainText)
        RichTextBox6.Focus()
        BDSCchanged = False
    End Sub
    Private Sub Button39_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button39.Click
        Dim Filenamepath As String
        Dim Filepath As String
        Filepath = "c:\N8VEM"
        SaveFileDialog1.InitialDirectory = Filepath
        SaveFileDialog1.FileName = BDSCfile ' ? put CPM files somewhere safe
        SaveFileDialog1.ShowDialog()
        Filenamepath = SaveFileDialog1.FileName
        Try
            RichTextBox6.SaveFile(Filenamepath, RichTextBoxStreamType.PlainText)
            BDSCfile = Strings.Mid(Filenamepath, 10)
            Label12.Text = BDSCfile
            RichTextBox6.Focus()
        Catch ex As Exception
            're user probably hit cancel
        End Try
    End Sub
    Private Sub Button40_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button40.Click
        Dim Filename As String
        Call CompileBDSC()
        Filename = Strings.Left(BDSCfile, Len(BDSCfile) - 2) ' ends in .C
        Call StringToPacket(Filename + vbCrLf)
    End Sub
    Sub CompileBDSC()
        Dim Location As New Process
        Dim Filename1 As String
        Dim i As Integer
        Try
            Call SaveBDSC()
            TextBox1.Text = ""
            TextBox1.Refresh()
            Filename1 = Strings.Left(BDSCfile, Len(BDSCfile) - 2) ' remove extension
            FileCopy("C:\N8VEM\" + Filename1 + ".C", "C:\N8VEM\AltairSIMH\" + Filename1 + ".C")
            Location.StartInfo.FileName = "AltairAllTelnet.bat" ' order of disks in file telnet
            Location.StartInfo.WorkingDirectory = "C:\n8vem\AltairSIMH"
            Location.Start() ' shell the batch file
            w3sock.TimeOut = 5000 ' long enough to do a compile for a big program?
            w3sock.DoTelnetEmulation = True
            w3sock.TelnetEmulation = "TTY"
            w3sock.Host = "Localhost:23"
            w3sock.Open()
            w3sock.WaitFor(">")
            w3sock.SendText("E:" + vbCrLf) ' change to drive E
            Sleep(200)
            w3sock.WaitFor(">")
            w3sock.SendText("R " + Filename1 + ".C" + vbCrLf) ' copy to the simh from pc directory
            Sleep(200)
            w3sock.WaitFor(">")
            w3sock.SendText("CC " + Filename1 + vbCrLf) ' compile
            Sleep(100) ' will take longer than this
            w3sock.SendText("CLINK " + Filename1 + vbCrLf) ' compile
            Sleep(100) ' will take longer than this
            w3sock.WaitFor("E>") ' wait for the E> prompt to come back
            Call RefreshTextBox1() ' display error messages etc as they come in
            For i = 1 To 2
                w3sock.SendText(vbCrLf) ' in case hangs send a few CRs
                Sleep(200)
                w3sock.WaitFor(">")
            Next
            w3sock.SendText("W " + Filename1 + ".COM" + vbCrLf) ' write back to PC directory
            Sleep(100)
            w3sock.WaitFor(">")
            RefreshTextBox1()
            For i = 1 To 2
                w3sock.SendText(vbCrLf) ' in case hangs send a couple of CRs
                Sleep(100)
                w3sock.WaitFor(">")
            Next
            ' erase the files on the simh otherwise fill up the 1mb disk image
            w3sock.SendText("ERA " + Filename1 + ".C" + vbCrLf) ' so don't clutter up simulated drive D
            Sleep(100)
            w3sock.WaitFor(">")
            Call RefreshTextBox1()
            w3sock.SendText("ERA " + Filename1 + ".COM" + vbCrLf)
            Sleep(100)
            w3sock.WaitFor(">")
            'now halt the simh program
            w3sock.SendText("HALT" + vbCrLf) ' halt the simh
            Call RefreshTextBox1()
            ' now copy file to c:\N8VEM
            FileCopy("C:\N8VEM\AltairSIMH\" + Filename1 + ".COM", "C:\N8VEM\" + Filename1 + ".COM")
            Kill("C:\N8VEM\AltairSIMH\" + Filename1 + ".C") ' clean up
            Kill("C:\N8VEM\AltairSIMH\" + Filename1 + ".COM") ' clean up
            ' and transfer it to the board
            w3sock.Close() ' close the socket
            TabControl1.SelectedIndex = 0 ' to tab 0
            TextBox3.Focus() ' focus to cp/m window
            System.Windows.Forms.Application.DoEvents() ' update the display
            Call XModemFSend("C:\N8VEM\" + Filename1 + ".COM", True)
            ' and try running it
            ' disable running it for the moment
            'Call StringToPacket(Filename1 + vbCrLf)
        Catch ex As Exception
            ' errors eg if it didn't compile so there is no file to copy
            w3sock.Close() ' close the socket
            TextBox1.Text += vbCrLf + "Syntax error - aborting" + vbCrLf
            TextBox1.Refresh()
            TextBox1.SelectionStart = TextBox1.TextLength
            TextBox1.ScrollToCaret()
            TabControl1.SelectedIndex = 2 ' tab 2 has the error message
            TextBox1.Focus() ' cursor to textbox1 so highlights the error
        End Try
    End Sub

    Private Sub PCToZicogToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PCToZicogToolStripMenuItem.Click
        ' slower than standard xmodem
        Dim Filenamepath As String
        Dim Filepath As String
        Dim Result
        Filepath = "c:\N8VEM"
        OpenFileDialog1.Multiselect = True
        OpenFileDialog1.InitialDirectory = Filepath
        OpenFileDialog1.FileName = "*.*" ' ? put CPM files somewhere safe
        Result = OpenFileDialog1.ShowDialog()
        If Result = 1 Then ' clicked ok 
            For Each Filenamepath In OpenFileDialog1.FileNames
                Call XModemZSend(Filenamepath, True)
            Next Filenamepath
        End If
    End Sub
    Sub XModemZSend(ByRef FName As String, ByVal TimerRestart As Boolean)
        Dim Filenamepath As String
        Dim j As Integer
        Dim k As Integer
        Dim LineOfText As String
        Dim SerialString As String
        Dim Counter As Integer
        Dim ErrorString As String
        Dim Packetnumber As Integer
        Dim Checksum As Long
        Dim OnesComplement As Byte
        Dim ByteRead As Byte
        Dim BinaryFileLength As Long
        Dim BinaryFileCounter As Long
        Dim Percent As Single
        Dim ErrorCounter As Byte ' 0 to 10
        Dim CPMFilename As String
        ProgressBar1.Maximum = 100
        ProgressBar1.Minimum = 0
        ' timer restart =true for sending via menu. False for auto send
        Filenamepath = FName
        Packetnumber = 1 ' 1 for the first packet (not zero)
        Try
            Dim Input As New FileStream(Filenamepath, FileMode.Open, FileAccess.Read)
            Dim br As New BinaryReader(Input)
            Label3.Text = "Error Count"
            Label2.Text = "0%"
            BinaryFileLength = br.BaseStream.Length() - 1
            'i = Len(Filepath) + 1 + 1  ' eg c:\n8vem and a \ = 9 and 1 more for start of name only
            Call Get_CPM_Filename(Filenamepath, CPMFilename)
            CPMFilename = Strings.UCase(CPMFilename)
            LineOfText = "ERA " + CPMFilename + vbCr
            Call StringToPacket(LineOfText)
            Sleep(500) ' 1000 for 4800
            ' mod June 2009 to run new xmodemf which deletes and undone again as doesnt work
            LineOfText = "XMODEMF R " + CPMFilename + vbCr
            Call StringToPacket(LineOfText) ' 
            'LineOfText = vbCrLf
            'Call StringToPacket(LineOfText) ' send a return/LF
            Sleep(500) ' wait for text to come back before disabling timer
            ' 100 is a bit short, 300 works, 200 seems a bit better 
            ' xmodem is taking 2 seconds to acknowledge so have at least this much time
            ' to get the text back
            If TimerRestart = False Then
                Call ClearInputBuffer()  ' clear the buffer into the PC
            End If
            If TimerRestart = True Then Timer1.Enabled = False 'disable echo and all reads so can control them below
            ' if timerrestart=false then called from a program where it is already disabled
            ' now wait for the N8VEM to send a chr(21) - will still be echoing back the text for a bit
            Do
                SerialString = ""
                If SerialPortFound = True Then
                    If SerialPort.BytesToRead > 0 Then
                        SerialPort.Read(InPacket, 0, 1) ' get one byte
                        SerialString = Chr(InPacket(0)) ' get a single character/string/byte
                    End If
                End If
                If InPacket(0) = 21 Then
                    ErrorString = "NAK"
                    Exit Do ' got a ^U
                End If
                If SerialString <> "" Then
                    'LineOfText = SerialString
                    'Call TextLines(LineOfText) ' print it out unless it is a chr21
                End If
                Counter = Counter + 1
                Sleep(10) ' don't change this one - this is waiting for NAK
                Label1.Text = "Waiting for NAK to start" + Strings.Str(Counter * 10) + "ms" ' display in milliseconds
                System.Windows.Forms.Application.DoEvents() ' update the label1 message
                ' add a counter and timeout if nothing
                If Counter > 200 Then
                    ErrorString = "Timeout"
                    Exit Do
                End If
                If ErrorString <> "" Then Exit Do
            Loop
            Label1.Text = ErrorString
            ' bug with vb.net - strings don't go to 255 so have to send data as bytes
            Do
                ' act on each byte in the buffer array here
                Sleep(1) ' 60 for 4800 but 1 working for 38400
                'If Radio1200 = True Then Sleep(250)
                XOut(0) = 1 'SOH ^A
                XOut(1) = Packetnumber
                OnesComplement = 255 - Packetnumber
                XOut(2) = OnesComplement
                Packetnumber = Packetnumber + 1
                If Packetnumber > 255 Then Packetnumber = Packetnumber - 256
                Checksum = 0
                For i = 0 To 127 ' get 128 bytes from file
                    If BinaryFileCounter <= BinaryFileLength Then
                        ByteRead = br.ReadByte ' get a byte
                    Else
                        ByteRead = 26 ' pad with char 26 = hex 1A because hyperterm does this ? why but it works
                    End If
                    XOut(i + 3) = ByteRead
                    Checksum = Checksum + ByteRead
                    BinaryFileCounter = BinaryFileCounter + 1
                Next
                ' create checksum
                Do
                    If Checksum < 256 Then Exit Do ' work out checksum
                    Checksum = Checksum - 256
                Loop
                XOut(131) = Checksum
                Call OutputZicog()
                System.Windows.Forms.Application.DoEvents() ' update the label
                Do
                    k = 0
                    Do
                        Sleep(10) '80 for 4800  wait for the acknowledge which is a character 6 delay of 80 only occasionally loops so k>0
                        If SerialPortFound = True Then
                            j = SerialPort.BytesToRead
                        End If
                        If j >= 1 Then
                            If SerialPortFound = True Then
                                SerialPort.Read(InPacket, 0, 1) ' get one byte
                            End If
                            Exit Do
                        End If
                        k = k + 1
                        If k > 300 Then ' much longer delay for the zicog = 3 secs so sd can write etc
                            InPacket(0) = 0 ' for below error testing
                            Exit Do
                        End If
                    Loop
                    If InPacket(0) = 6 Then Exit Do ' board got the packet
                    If InPacket(0) = 21 Or InPacket(0) = 0 Then
                        ' didn't get it so try sending again
                        ErrorCounter = ErrorCounter + 1
                        Call OutputXout()
                        If InPacket(0) = 0 Then
                            Label3.Text = "Timeout error"
                        Else
                            Label3.Text = "Error: " + Strings.Str(ErrorCounter)
                        End If
                        System.Windows.Forms.Application.DoEvents() ' update the label
                    End If
                    Label3.Text = "Error: " + Strings.Str(ErrorCounter)
                    System.Windows.Forms.Application.DoEvents() ' update the label
                    If ErrorCounter >= 3 Then Exit Do ' snandard xmodem is 10 but make this 3
                Loop
                If ErrorCounter >= 10 Then
                    Label1.Text = "10 errors - aborting"
                    Label2.Text = "0%"
                    OutPacket(0) = 24 ' send a ^X cancel
                    If SerialPortFound = True Then
                        SerialPort.Write(OutPacket, 0, 1) ' send 1 byte
                        OutPacket(0) = 3 ' send a ^C
                        SerialPort.Write(OutPacket, 0, 1) ' send 1 byte
                    End If
                    Exit Do
                End If
                If BinaryFileCounter > BinaryFileLength Then Exit Do ' finish up
                Label1.Text = "Sent packet: " + Strings.Str(Packetnumber) + " = OK"
                Percent = BinaryFileCounter / BinaryFileLength
                Percent = Percent * 100
                Percent = Int(Percent)
                Label2.Text = Strings.Str(Percent) + "%"
                ProgressBar1.Value = Percent
            Loop
            If ErrorCounter < 3 Then
                Sleep(100)
                OutPacket(0) = 4
                If SerialPortFound = True Then
                    SerialPort.Write(OutPacket, 0, 1) ' send 1 byte
                End If
                Label2.Text = "100%"
                Label1.Text = "Finished"
                ProgressBar1.Value = 0 'done
            End If
            Input.Close()
            Sleep(200) ' wait for next file
            If TimerRestart = True Then Timer1.Enabled = True ' update the text - no sleeps after this
            System.Windows.Forms.Application.DoEvents() ' update the labels
        Catch ex As Exception
            Close()
            Label1.Text = Filenamepath + " not found"
            If TimerRestart = TimerRestart = True Then Timer1.Enabled = True ' update the text
            System.Windows.Forms.Application.DoEvents() ' update the labels
            Sleep(1000) ' so time to read message
        End Try
    End Sub
    Sub OutputZicog() ' uses xout() array and sends it out in pieces of 30 bytes
        ' in a subroutine so resends are easier - passing subroutine fills up the bytes
        ' 1. an SOH byte                             {1 byte}
        ' 2. the packet number                       {1 byte}
        ' 3:      .the(1) 's complement of the packet number {1 byte}
        ' 4. the packet                            {128 bytes}
        ' 5. the checksum                            {1 byte}

        'The following terms are simply ascii codes:
        'SOH = chr(1)  = CTRL-A =
        'EOT = chr(4)  = CTRL-D = End of Transmission
        'ACK = chr(6)  = CTRL-F = Positive Acknowledgement
        'NAK = chr(21) = CTRL-U = Negative Acknowledgement
        'CAN = Chr(24) = CTRL - X = Cancel
        'The packet number sent is simply the number of the packet.  If the packet
        'number is greater than 255, then subtract 256 repeatly until the number is
        'between 0 and 255.  For example, if you were sending packet 731, then you
        'would send 731 - 256 - 256 = 219.
        'The(1) 's complement of a byte (to make life easy) is simply 255 minus the
        'byte.  For example, if you had to take the 1's complement of 142, the answer
        'would be 255 - 142 = 133.

        'The checksum is the value of all the bytes in the packet added together.  For
        'example, if the first five bytes were 45, 12, 64, 236, 173 and the other 123
        'bytes were zeroes, the checksum would be 45+12+64+236+173+0+0+...+0 = 530.
        'However, to make each block one byte smaller, they repeatly subtract 256
        'from the checksum until it is between 0 and 255.  In this case, the checksum
        'would be 530 - 256 - 256 = 18.
        'The(downloader)

        '1. ensures that the packet number sent matches the actual packet number
        'that it is (If the third block send has a '4' as the second byte,
        'something is wrong --> CANCEL TRANSFER (send CAN byte))
        '2. adds the packet number and the 1's complement of it together to make
        'sure that they add up to 255.  if they don't --> CANCEL TRANSFER
        '3. adds up all the bytes in the packet together --> THE SUM
        '4. compares the last two significant digits of THE SUM with the checksum
        '5. if everything looks ok (sum=checksum), then the downloader appends the
        'bytes in the packet to the file being created (sent).  The down-
        'loader then sends an ACK byte which tells the uploader to send the
        'next block.
        'if the sums do not match then the downloader sends an NAK byte which
        'tells the uploader to send the same block it just sent over again.

        ' send in blocks of 30 bytes to keep the Hope module happy
        ' removed the 30 byte block for the moment, hope modules go via boards not pc to board
        Dim i, j As Integer
        For i = 0 To 131
            OutPacket(i) = XOut(i)
        Next
        If SerialPortFound = True Then
            SerialPort.Write(OutPacket, 0, 132)
        End If
        ' very slow code to catch bugs etc
        'Dim LineOfText As String
        'For i = 0 To 131
        ' OutPacket(0) = XOut(i)
        ' SerialPort.Write(OutPacket, 0, 1)
        ' 'lineoftext = Chr(XOut(i)) ' + "  " + Str(XOut(i))
        ' 'Call DisplayCharacter(lineoftext)
        ' 'Call RedrawDisplay()
        ' 'System.Windows.Forms.Application.DoEvents()
        ' 'Sleep(1) ' need a delay talking to the zicog
        ' Next
        ' try sending in groups of 32 (? due to the 64 byte buffer in the uart)


    End Sub

    Private Sub ToolStripMenuItem8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItem8.Click
        'TypematicSlow = False
        'Call StringToPacket("19200" + vbCrLf)
        If SerialPortFound = True Then
            SerialPort.BaudRate = "19200"
        End If
        Sleep(300) ' delay to do it
        Call StringToPacket(vbCrLf)
    End Sub

    Private Sub ToolStripMenuItem9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItem9.Click
        'TypematicSlow = False
        'Call StringToPacket("38400" + vbCrLf)
        If SerialPortFound = True Then
            SerialPort.BaudRate = "38400" ' 38400
        End If
        Sleep(300) ' delay to do it
        Call StringToPacket(vbCrLf)
    End Sub
End Class
